! 
!
!***************************************************************************
!  Sproeval.f90 
!*
!* (C) Copyright 1991-2002 Rainbow Technologies, Inc. All rights reserved.
!
! Description : SentinelSuperPro Evaluation Program for WIN32 using Fortran Language.*
! Purpose     : To demostrate the SentinelSuperPro API for Fortran languages
!               running under Windows.
!****************************************************************************

!****************************************************************************
!
!  FUNCTION: WinMain( hInstance, hPrevInstance, lpszCmdLine, nCmdShow )
!
!  PURPOSE:  Entry point for the application
!
!  COMMENTS: Displays the main window and processes the message loop
!
!****************************************************************************
	
	! use spromeps_constants
integer*4 function WinMain( hInstance, hPrevInstance, lpszCmdLine, nCmdShow )
!DEC$ IF DEFINED(_X86_)
!DEC$ ATTRIBUTES STDCALL, ALIAS : '_WinMain@16' :: WinMain
!DEC$ ELSE
!DEC$ ATTRIBUTES STDCALL, ALIAS : 'WinMain' :: WinMain
!DEC$ ENDIF

	! Includes Files and modules
	use dfwin
	use dflogm
	use SproevalGlobals
	use spromeps_module
	! use spromeps_constants
	implicit none

	integer*4 hInstance
	integer*4 hPrevInstance
	integer*4 lpszCmdLine
	integer*4 nCmdShow
	include 'resource.fd'

	! external SUBROUTINES
	external InitMain
	external sproFormatPacket
	external sproInitialize
	external sproSetProtocol
	external sproFindFirst
	external sproFindNext
	external sproSetHeartBeat
	external sproRead
	external sproXread
	external sproWrite
	external sproOverwrite
	external sproQuery
	external sproActivate
	external sproDecrement
	external sproGetVersion
	external sproGetHardLimit
	external sproGetFullStatus
	external sproGetKeyInfo
	external sproGetSubLicense
	external sproReleaseLicense
	external sproEnumServer
	external sproGetContactServer
	external sproSetContactServer
	external KeyView
	external CompanyInfo
	external Help
	external ExitMain
	external intTohex
	
	! Variables
	type (dialog)			dlg,Find_dlg
	type (T_MSG)            mesg

	ghInstance = hInstance
	ghModule = GetModuleHandle(NULL)


	! Initialize main dialog
	lret = DlgInit(MAIN_DIALOG, dlg)
	
	if (lret) then
		
		! link diffrent subroutine for diffrent event 
		! To call during MAIN Dialof initialization
		lret = DlgSetSub(dlg, MAIN_DIALOG, InitMain)
		
		! On FormatPacket API button click
		lret = DlgSetSub(dlg, SP_API_FMT, sproFormatPacket)
		! On Initialize API button click
		lret = DlgSetSub(dlg, SP_API_INIT, sproInitialize)
		! On SetProtocol API button click
		lret = DlgSetSub(dlg, SP_API_SETPROTOCOL, sproSetProtocol)
		! On FindFirst API button click
		lret = DlgSetSub(dlg, SP_API_FF, sproFindFirst)
		! On FindNext API button click
		lret = DlgSetSub(dlg, SP_API_FN, sproFindNext)
		! On SetHeartBeat API button click
		lret = DlgSetSub(dlg, SP_API_SETHEARTBEAT, sproSetHeartBeat)
		! On Read API button click
		lret = DlgSetSub(dlg, SP_API_RD, sproRead)
		! On ExtendedRead API button click
		lret = DlgSetSub(dlg, SP_API_XRD, sproXread)
		! On Write API button click
		lret = DlgSetSub(dlg, SP_API_WT, sproWrite)
		! On Overwrite API button click
		lret = DlgSetSub(dlg, SP_API_OWT, sproOverwrite)
		! On Query API button click
		lret = DlgSetSub(dlg, SP_API_QRY, sproquery)
		! On Activate API button click
		lret = DlgSetSub(dlg, SP_API_ACT, sproActivate)
		! On Decrment API button click
		lret = DlgSetSub(dlg, SP_API_DEC,sproDecrement)
		! On GetVersion API button click
		lret = DlgSetSub(dlg, SP_API_GV, sproGetVersion)
		! On GetHardLimit API button click
		lret = DlgSetSub(dlg, SP_API_GET_HARDLMT, sproGetHardLimit)
		! On FullStatus API button click
		lret = DlgSetSub(dlg, SP_API_GFS, sproGetFullStatus)
		! On KeyInfo API button click
		lret = DlgSetSub(dlg, SP_API_GET_KEY_INFO, sproGetKeyInfo)
		! On SubLicense API button click
		lret = DlgSetSub(dlg, SP_API_GET_SUB_LIC, sproGetSubLicense)
		! On ReleaseLicense API button click
		lret = DlgSetSub(dlg, SP_API_RELEASE, sproReleaseLicense)
		! On EnumServer API button click
		lret = DlgSetSub(dlg, SP_API_ENUMSRVR, sproEnumServer)
		! On GetContactServer API button click
		lret = DlgSetSub(dlg, SP_API_GET_CONTACT_SERVER, sproGetContactServer)
		! On SetContactServer API button click
		lret = DlgSetSub(dlg, SP_API_SET_CONTACT_SERVER, sproSetContactServer)
		! On KeyView API button click	
		lret = DlgSetSub(dlg, SP_VW, KeyView)
		! On CompanyInfo button click
		lret = DlgSetSub(dlg, SP_NFO, CompanyInfo)
		! On Help call
		lret = DlgSetSub(dlg, SP_HLP, Help)
		! On Main dialog close
		lret = DlgSetSub(dlg, IDCANCEL, ExitMain)

				
		lret = DlgModal(dlg)

		! Read and process messsages
		do while( GetMessage (mesg, NULL, 0, 0) ) 
			if ( DlgIsDlgMessage(mesg) .EQV. .FALSE. ) then
				lret = TranslateMessage( mesg )
				ret  = DispatchMessage( mesg )
			end if
		end do
		call DlgUninit(dlg)

		WinMain = mesg.wParam
		return

	end if

	99999 &

	ret = MessageBox(ghwndMain, "Error initializing application Sproeval"C, &
					 "Error"C, MB_OK)
	WinMain = 0

end 

!****************************************************************************
!
! End of  FUNCTION: Winmain
!
!****************************************************************************

!****************************************************************************
!
!  FUNCTION: InitMain( dlg, id, callbacktype )
!
!  PURPOSE:  This function is called during initialazation of main dilaog.
!
!  COMMENTS:Some operaion will perform here at initilization time
!
!****************************************************************************

SUBROUTINE InitMain( dlg, id, callbacktype )

  use dflogm ! include file for Fortarn
  use dfwin ! include header file for fortran
  use SPROEVALGlobals ! file for global variables
  use spromeps_module ! file for API wrappers
  ! use spromeps_constants ! file for Constant and structure defination

  type (dialog) dlg
  integer id, callbacktype

  
	if (callbacktype == dlg_destroy) then
		call PostQuitMessage(0)
	else
		! ***Comment: FormatPacket API is called during initialization of main dialog ***
		status = RNBOsproFormatPacket (RNBOpacket%packet, SPRO_APIPACKET_SIZE)
		if (status <> 0) then
			call PostQuitMessage(0)
		endif
	endif

END SUBROUTINE InitMain

!****************************************************************************
!
! End of  FUNCTION: InitMain
!
!****************************************************************************

!****************************************************************************
!
!  FUNCTION: FormatPacket ( dlg, id, callbacktype )
!
!  PURPOSE:  This function executes when FormatPacket button clicks
!
!  COMMENTS:RNBOsproFormatPacket API call here
!
!****************************************************************************

SUBROUTINE sproFormatPacket( dlg, id, callbacktype )

  use dflogm ! include file for Fortarn
  use dfwin ! include header file for fortran
  use SPROEVALGlobals ! file for global variables
  use spromeps_module ! file for API wrappers
  ! use spromeps_constants ! file for Constant and structure defination
  integer messageBox_Icon
  type (dialog) dlg
  integer id, callbacktype
	! ***Comment: include resource header file ****
	include 'resource.fd' 
  
	if (callbacktype == dlg_clicked) then
		
		ret=LoadString( NULL,IDS_FMT,Boxtitle,len(Boxtitle)) 
		messageBox_Icon = MB_TASKMODAL

		! RNBOsproFormatPacket API call
		status = RNBOsproFormatPacket (RNBOpacket%packet, SPRO_APIPACKET_SIZE)

		! ***Comment: check whether API get success or not ****
		if(status==0) then
			ret = LoadString( NULL,IDS_FMT_SUCCESS,OutMessage,len(OutMessage)) 
			ret = MessageBox(NULL,OutMessage , &
											 Boxtitle,messageBox_Icon )
			return
		else
			ret = LoadString( NULL,IDS_ERR_FMT_FAILED,OutMessage,len(OutMessage)) 
			! convert reurn code into string
			write (String_status,'(I3,A)')  status ,'.'
			! concat failure mess
			call Pass_Str(OutMessage,String_status)
			
			ret = MessageBox(NULL, OutMessage, &
											 Boxtitle, messageBox_Icon)
			return
		endif
  endif
END SUBROUTINE sproFormatPacket
!****************************************************************************
!
! End of  FUNCTION: sproFormatPacket
!
!****************************************************************************


!****************************************************************************
!
!  FUNCTION: Initialize ( dlg, id, callbacktype )
!
!  PURPOSE:  This function executes when Initialize  button clicks
!
!  COMMENTS:RNBOsproInitialize API call here
!
!****************************************************************************

SUBROUTINE sproInitialize( dlg, id, callbacktype )

 use dflogm ! include file for Fortarn
  use dfwin ! include header file for fortran
  use SPROEVALGlobals ! file for global variables  !se spromeps_module ! file for API wrappers
! file for Constant and structure defination
  ! ***Comment: include resource header file ****
  include 'resource.fd'
  type (dialog) dlg
  integer id, callbacktype
  integer messageBox_Icon
  String_OutMessage = ""C
  OutMessage = ""C ! make ourput string blank
  String_status=""C ! make ourput string blank
	if (callbacktype == dlg_clicked) then
		messageBox_Icon =  MB_TASKMODAL
		ret=LoadString( NULL,IDS_INIT,Boxtitle,len(Boxtitle)) 

		! RNBOsproInitialize API call
		status = RNBOsproInitialize (RNBOpacket%packet)

		! ***Comment: check whether API get success or not ****
		if(status==0) then
			
			ret = LoadString( NULL,IDS_INIT_SUCCESS,OutMessage,len(OutMessage)) 
			
			ret = MessageBox(NULL,OutMessage , &
											 Boxtitle, messageBox_Icon)
			return
		else
			ret = LoadString( NULL,IDS_ERR_INIT_FAILED,OutMessage,len(OutMessage)) 
			! convert reurn code into string
			write (String_status,'(I3,a)')  status,'.'
			! concat failure mess
			call Pass_Str(OutMessage,String_status)
				
			ret = MessageBox(NULL, OutMessage , &
											 Boxtitle , messageBox_Icon )
			return
		endif
  endif
END SUBROUTINE sproInitialize

!****************************************************************************
!
! End of  FUNCTION: Initialize
!
!****************************************************************************


!****************************************************************************
!
!  SUBROUTINE sproSetProtocol( dlg, id, callbacktype )
!
!  PURPOSE:  This function executes when SetProtocol  button clicks
!
!  COMMENTS:SetProtocol dialog gets initilaze and set default values here
!
!****************************************************************************

SUBROUTINE sproSetProtocol( dlg, id, callbacktype )

use dflogm ! include file for Fortarn
  use dfwin ! include header file for fortran
  use SPROEVALGlobals ! file for global variables
  use spromeps_module ! file for API wrappers
  ! use spromeps_constants ! file for Constant and structure defination
  implicit none

  external SetProtocol_ONOK
  ! ***Comment: include resource header file ****
	include 'resource.fd'
  type (dialog) dlg,SetProtocol_dlg
  integer id, callbacktype

  if (callbacktype == dlg_clicked) then
		lret = DlgInit(SET_PROTOCOL_DIALOG, SetProtocol_dlg)
		if (lret) then
			
			! ***Comment: Set ComboBox value for protocol ****
			lret = DlgSetSub(SetProtocol_dlg, IDOK, SetProtocol_ONOK)
			lret = DlgSet (SetProtocol_dlg, IDC_CMBPROTOCOL, 4, DLG_NUMITEMS )
			
			lret = DlgSet (SetProtocol_dlg, IDC_CMBPROTOCOL, TRUE, DLG_ENABLE  )
			lret = DlgSet (SetProtocol_dlg, IDC_CMBPROTOCOL, "NSPRO_TCP_PROTOCOL", 1 )
			lret = DlgSet (SetProtocol_dlg, IDC_CMBPROTOCOL, "NSPRO_IPX_PROTOCOL", 2 )
			lret = DlgSet (SetProtocol_dlg, IDC_CMBPROTOCOL, "NSPRO_NETBEUI_PROTOCOL", 3 )
			lret = DlgSet (SetProtocol_dlg, IDC_CMBPROTOCOL, "NSPRO_SAP_PROTOCOL", 4 )
			
			!show SetProtocol dialog box
			lret = DlgModal(SetProtocol_dlg)

		endif
	end if

END SUBROUTINE sproSetProtocol
!****************************************************************************
!
! End of  FUNCTION: sproSetProtocol
!
!****************************************************************************

!****************************************************************************
!
!  SUBROUTINE sproFindFirst( dlg, id, callbacktype )
!
!  PURPOSE:  This function executes when FindFirstUnit  button clicks
!
!  COMMENTS:FindFirstUnit dialog gets initilaze  here
!
!****************************************************************************

SUBROUTINE sproFindFirst( dlg, id, callbacktype )

use dflogm ! include file for Fortarn
  use dfwin ! include header file for fortran
  use SPROEVALGlobals ! file for global variables
  use spromeps_module ! file for API wrappers
  ! use spromeps_constants ! file for Constant and structure defination
  implicit none
  external FindFirstUnit_ONOK ! called on click of OK button of this dialog
  
  ! Include resource header file here
	include 'resource.fd'
  type (dialog) dlg,Find_dlg
  integer id, callbacktype

  if (callbacktype == dlg_clicked) then
		lret = DlgInit(FIND_DIALOG, Find_dlg)
		if (lret) then
			! set subroutine call with OK button
			lret = DlgSetSub(Find_dlg, IDOK, FindFirstUnit_ONOK)
			lret = DlgModal(Find_dlg) ! show FindFirst Dialog
		endif
	end if
END SUBROUTINE sproFindFirst

!****************************************************************************
!
! END SUBROUTINE sproFindFirst
!
!****************************************************************************


!****************************************************************************
!
!  SUBROUTINE sproFindNext( dlg, id, callbacktype )
!
!  PURPOSE:  This function executes when FindNextUnit  button clicks
!
!  COMMENTS:RNBOsproFindNextUnit API call here
!
!****************************************************************************

SUBROUTINE sproFindNext( dlg, id, callbacktype )

use dflogm ! include file for Fortarn
  use dfwin ! include header file for fortran
  use SPROEVALGlobals ! file for global variables
  use spromeps_module ! file for API wrappers
  ! use spromeps_constants ! file for Constant and structure defination
  implicit none
  type (dialog) dlg
  integer id, callbacktype
  include 'resource.fd' ! respource headre file for fortran
  integer messageBox_Icon ! variable for displaying icon in message box
  if (callbacktype == dlg_clicked) then
		! load resource string value
		ret=LoadString( NULL,IDS_FINDNEXT,Boxtitle,len(Boxtitle)) 
		! assign value for message box type variable
		messageBox_Icon =  MB_TASKMODAL
		
		! RNBOsproFindNextUnit API call
		status = RNBOsproFindNextUnit(RNBOpacket%packet)

		! ***Comment: check whether API get success or not ****		
		if(status==0) then
			! load respource string here
			ret = LoadString( NULL,IDS_ERR_FINDNEXT_SUCC,OutMessage,len(OutMessage)) 
			!display API success message
			ret = MessageBox(NULL,OutMessage , &
											 Boxtitle, messageBox_Icon)
			return
		else
			! load respources string
			ret = LoadString( NULL,IDS_ERR_FINDNEXT_FAILED,OutMessage,len(OutMessage)) 
			! write value of API return code into string variable
			write (String_status,'(I3,a)')  status ,'.'
			! concat Failure message and reurn code 
			call Pass_Str(OutMessage,String_status)
			! display messaage box with API failure nad return code message
			ret = MessageBox(NULL, OutMessage, &
											 Boxtitle, messageBox_Icon)
			return
		endif
  end if
	
END SUBROUTINE sproFindNext

!****************************************************************************
!
! END SUBROUTINE sproFindNext
!
!****************************************************************************

!****************************************************************************
!
!  SUBROUTINE sproSetHeartBeat( dlg, id, callbacktype )
!
!  PURPOSE:  This function executes when SetHeartBeat  button clicks
!
!  COMMENTS:SetHeartBeat dialog gets initilaze  here
!
!****************************************************************************

SUBROUTINE sproSetHeartBeat( dlg, id, callbacktype )
 use dflogm ! include file for Fortarn
  use dfwin ! include header file for fortran
  use SPROEVALGlobals ! file for global variables
  use spromeps_module ! file for API wrappers
  ! use spromeps_constants ! file for Constant and structure defination
  implicit none
 external	SetHeartBeat_ONOK ! subroutine linked with OK button
 include 'resource.fd'

 type (dialog) dlg,SetHeartBeat_dlg
 integer id, callbacktype

  if (callbacktype == dlg_clicked) then
		lret = DlgInit(SET_HEARTBEAT_DIALOG, SetHeartBeat_dlg)
		if (lret) then
			! link subroutine for OK buttun click event
			lret = DlgSetSub(SetHeartBeat_dlg, IDOK, SetHeartBeat_ONOK)
			lret = DlgModal(SetHeartBeat_dlg)
		endif
	end if
END SUBROUTINE sproSetHeartBeat


!****************************************************************************
!
! END SUBROUTINE sproSetHeartBeat
!
!****************************************************************************

!****************************************************************************
!
!  SUBROUTINE sproRead( dlg, id, callbacktype )
!
!  PURPOSE:  This function executes when Read  button clicks
!
!  COMMENTS:Read dialog gets initilaze  here
!
!****************************************************************************

SUBROUTINE sproRead( dlg, id, callbacktype )

  use dflogm ! include file for Fortarn
  use dfwin ! include header file for fortran
  use SPROEVALGlobals ! file for global variables
  use spromeps_module ! file for API wrappers
  ! use spromeps_constants ! file for Constant and structure defination

  implicit none
  ! declaration for eternal subroutine
  external ReadCelladdress
  external Read_ONOK

  include 'resource.fd'

  type (dialog) dlg,Read_dlg
  integer id, callbacktype

  if (callbacktype == dlg_clicked) then
		lret = DlgInit(READ_DIALOG, Read_dlg)
		if (lret) then
			!ReadCelladdress SUB call at time of Read dialog loading
			lret = DlgSetSub(Read_dlg, READ_DIALOG, ReadCelladdress)
			! Read_ONOK will call on OK button click
			lret = DlgSetSub(Read_dlg, IDOK, Read_ONOK)
			lret = DlgModal(Read_dlg)
		endif
	end if

END SUBROUTINE sproRead


!****************************************************************************
!
! END SUBROUTINE sproRead
!
!****************************************************************************


!****************************************************************************
!
!  SUBROUTINE sproXread( dlg, id, callbacktype )
!
!  PURPOSE:  This function executes when ExtendedRead  button clicks
!
!  COMMENTS:ExtendedRead dialog gets initilaze  here
!
!****************************************************************************

SUBROUTINE sproXread( dlg, id, callbacktype )

use dflogm ! include file for Fortarn
  use dfwin ! include header file for fortran
  use SPROEVALGlobals ! file for global variables
  use spromeps_module ! file for API wrappers
  ! use spromeps_constants ! file for Constant and structure defination
  implicit none
  ! declaration for eternal subroutine
  external XreadCelladdress
  external Xread_ONOK
  include 'resource.fd'

  type (dialog) dlg,Xread_dlg
  integer id, callbacktype

  if (callbacktype == dlg_clicked) then
		lret = DlgInit(XREAD_DIALOG, Xread_dlg)
		if (lret) then
			!ReadCelladdress SUB call at time of Read dialog loading
			lret = DlgSetSub(Xread_dlg, XREAD_DIALOG, XreadCelladdress)
			! Read_ONOK will call on OK button click
			lret = DlgSetSub(Xread_dlg, IDOK, Xread_ONOK)
			lret = DlgModal(Xread_dlg)
		endif
	end if
END SUBROUTINE sproXread


!****************************************************************************
!
! END SUBROUTINE sproXread
!
!****************************************************************************


!****************************************************************************
!
!  SUBROUTINE sproWrite( dlg, id, callbacktype )
!
!  PURPOSE:  This function executes when Write  button clicks
!
!  COMMENTS:Write dialog gets initilaze  here
!
!****************************************************************************

SUBROUTINE sproWrite( dlg, id, callbacktype )

use dflogm ! include file for Fortarn
  use dfwin ! include header file for fortran
  use SPROEVALGlobals ! file for global variables
  use spromeps_module ! file for API wrappers
  ! use spromeps_constants ! file for Constant and structure defination
  implicit none
  external WriteCelladdress
  
  external Write_ONOK

  include 'resource.fd'
  type (dialog) dlg,Write_dlg
  integer id, callbacktype

  if (callbacktype == dlg_clicked) then
		lret = DlgInit(WRITE_DIALOG, Write_dlg)
		if (lret) then
			
			! Set CellAdress and accessCode value in ListBox
			lret = DlgSetSub(Write_dlg, WRITE_DIALOG, WriteCelladdress)
			! Set previous enter value for write password
			lret = DlgSet(Write_dlg, WR_PW, String_writePassword)
			! call on OK button Click
			lret = DlgSetSub(Write_dlg, IDOK, Write_ONOK)
			lret = DlgModal(Write_dlg)
		endif
	end if

END SUBROUTINE sproWrite


!****************************************************************************
!
! END SUBROUTINE sproWrite
!
!****************************************************************************


!****************************************************************************
!
!  SUBROUTINE sproOverwrite( dlg, id, callbacktype )
!
!  PURPOSE:  This function executes when OverWrite  button clicks
!
!  COMMENTS:OverWrite dialog gets initilaze  here
!
!****************************************************************************

SUBROUTINE sproOverwrite( dlg, id, callbacktype )

use dflogm ! include file for Fortarn
  use dfwin ! include header file for fortran
  use SPROEVALGlobals ! file for global variables
  use spromeps_module ! file for API wrappers
  ! use spromeps_constants ! file for Constant and structure defination
  implicit none
! declaration for external subroutine
  external OverwriteCelladdress
  external Overwrite_ONOK


  include 'resource.fd' ! resource header file for fortran
  type (dialog) dlg,Overwrite_dlg
  integer id, callbacktype

  if (callbacktype == dlg_clicked) then
		lret = DlgInit(OWRITE_DIALOG, Overwrite_dlg)
		if (lret) then
			! Set CellAdress and accessCode value in ListBox
			lret = DlgSetSub(Overwrite_dlg, OWRITE_DIALOG, OverwriteCelladdress)
			! call on OK button click.
			lret = DlgSetSub(Overwrite_dlg, IDOK, Overwrite_ONOK)
			! Set previous enter value for Overwrite password1
			lret = DlgSet(Overwrite_DLG, OW_PW_1, String_OW1Password)
			! Set previous enter value for Overwrite password2
			lret = DlgSet(Overwrite_dlg, OW_PW_2, String_OW2Password)
			! Set previous enter value for write password
			lret = DlgSet(Overwrite_dlg, OW_PW_3, String_writePassword)
			lret = DlgModal(Overwrite_dlg)
		endif
	end if
END SUBROUTINE sproOverwrite


!****************************************************************************
!
!   END SUBROUTINE sproOverwrite
!
!****************************************************************************


!****************************************************************************
!
!  SUBROUTINE sproQuery( dlg, id, callbacktype )
!
!  PURPOSE:  This function executes when Query  button clicks
!
!  COMMENTS:Query dialog gets initilaze  here
!
!****************************************************************************

SUBROUTINE sproQuery( dlg, id, callbacktype )

use dflogm ! include file for Fortarn
  use dfwin ! include header file for fortran
  use SPROEVALGlobals ! file for global variables
  use spromeps_module ! file for API wrappers
  ! use spromeps_constants ! file for Constant and structure defination
  implicit none
  ! subroutine declaration here for this function
  external QueryCellAddress
  external Query_ONOK
  integer*4 nCmdShow
  include 'resource.fd'
  type (T_MSG)            mesg
  !integer*4			    ret
  !logical*4				lret
  type (dialog) dlg,Query_dlg
  integer id, callbacktype

  if (callbacktype == dlg_clicked) then
		lret = DlgInit(QUERY_DIALOG, Query_dlg)
		if (lret) then
			! Set Cell address value for Query dialog box
			lret = DlgSetSub(Query_dlg, QUERY_DIALOG, QueryCelladdress)
			! call on OK button click
			lret = DlgSetSub(Query_dlg, IDOK, Query_ONOK)
			lret = DlgModal(Query_dlg)
		endif
	end if
END SUBROUTINE sproQuery


!****************************************************************************
!
!   END SUBROUTINE sproQuery
!
!****************************************************************************


!****************************************************************************
!
!  SUBROUTINE sproDecrement( dlg, id, callbacktype )
!
!  PURPOSE:  This function executes when Decrement  button clicks
!
!  COMMENTS:Decrement dialog gets initilaze  here
!
!****************************************************************************

SUBROUTINE sproDecrement( dlg, id, callbacktype )

use dflogm ! include file for Fortarn
  use dfwin ! include header file for fortran
  use SPROEVALGlobals ! file for global variables
  use spromeps_module ! file for API wrappers
  ! use spromeps_constants ! file for Constant and structure defination
  implicit none
  external DecrementCellAddress
  external Decrement_ONOK
  include 'resource.fd'
  type (dialog) dlg,Decrement_dlg
  integer id, callbacktype

  if (callbacktype == dlg_clicked) then
		lret = DlgInit(DEC_DIALOG, Decrement_dlg)
		if (lret) then
			! Set cellAddress value for Decrement dialog
			lret = DlgSetSub(Decrement_dlg, DEC_DIALOG, DecrementCelladdress)
			! Call on OK button click of Decrement dialog
			lret = DlgSetSub(Decrement_dlg, IDOK, Decrement_ONOK)
			!Set previously Entered write passWord value for decrement dialog
			lret = DlgSet(Decrement_dlg, DEC_WP, String_writePassword)
			lret = DlgModal(Decrement_dlg)

		endif
	end if

END SUBROUTINE sproDecrement


!****************************************************************************
!
!END SUBROUTINE sproDecrement
!
!****************************************************************************


!****************************************************************************
!
!  FUNCTION: sproActivate ( dlg, id, callbacktype )
!
!  PURPOSE:  This function executes when Activate  button clicks
!
!  COMMENTS:Activate dialog gets initilaze  here
!
!****************************************************************************

SUBROUTINE sproActivate( dlg, id, callbacktype )

use dflogm ! include file for Fortarn
  use dfwin ! include header file for fortran
  use SPROEVALGlobals ! file for global variables
  use spromeps_module ! file for API wrappers
  ! use spromeps_constants ! file for Constant and structure defination
  implicit none
  external ActivateCell
  external Activate_ONOK
  include 'resource.fd'
  type (dialog) dlg,Activate_dlg
  integer id, callbacktype

  if (callbacktype == dlg_clicked) then
		lret = DlgInit(ACTIVATE_DIALOG, Activate_dlg)
		if (lret) then
			! Sel CellAddress value for Activate dialog
			lret = DlgSetSub(Activate_dlg,ACTIVATE_DIALOG,ActivateCell)
			! call on OK button click of Activate dialog
			lret = DlgSetSub(Activate_dlg, DRC_IDOK, Activate_ONOK)
			! set Previously entered value on Activate dialog box
			lret = DlgSet(Activate_dlg, ACT_WP, String_writePassword)
			lret = DlgModal(Activate_dlg)
		endif
	end if
END SUBROUTINE sproActivate


!****************************************************************************
!
! End of  FUNCTION: sproActivate
!
!****************************************************************************


!****************************************************************************
!
!  FUNCTION: sproGetVersion ( dlg, id, callbacktype )
!
!  PURPOSE:  This function executes when GetVersion  button clicks
!
!  COMMENTS:RNBOsproGetVersion API calls here
!
!****************************************************************************

SUBROUTINE sproGetVersion( dlg, id, callbacktype )

use dflogm ! include file for Fortarn
  use dfwin ! include header file for fortran
  use SPROEVALGlobals ! file for global variables
  use spromeps_module ! file for API wrappers
  ! use spromeps_constants ! file for Constant and structure defination

  implicit none
 include 'resource.fd'
  integer(kind=1) :: majVer, minVer, rev, dType ! variable to get version info
  character (len=32) :: driverString ! variable for driver type string
  type (dialog) dlg
  integer id, callbacktype
  integer messageBox_Icon
  character (len=110) VerInfo
	  if (callbacktype == dlg_clicked) then
		ret = LoadString( NULL,IDS_GET_VERSION,Boxtitle,len(Boxtitle)) 
		messageBox_Icon =  MB_TASKMODAL
		! RNBOsproGetVersion API call
		status = RNBOsproGetVersion (RNBOpacket%packet, majVer, minVer, rev, dType)
    
		! ***Comment: check whether API get success or not ****		
		if (status == 0) then
		
		! Generate string value for driver OS Type
		

		SELECT CASE (dType)
				CASE (5)
					driverString = ' (Windows NT system driver)'
				CASE (7)
					driverString = ' (Windows 95 system driver)'
				CASE (8)
					driverString = ' (Novell system driver)'
				CASE (10)
					driverString = ' (Unknown driver type)'
			END SELECT 
			! concat all version info value as single string to display
		
	
	write (VerInfo,'(A, I2,A, I2,A, I2,A,I2, A)') "Major Version =", majVer," , Minor Version =",minVer," , Revision =",rev," , DriverType =" ,dType,driverString
		ret = MessageBox(NULL, VerInfo , &
					 Boxtitle, messageBox_Icon)	
	else
	 	ret = LoadString( NULL,IDS_ERR_VERSION_FAILED,OutMessage,len(OutMessage)) 
		write (String_status,'(I3,A)')  status ,'.'
		call Pass_Str(OutMessage,String_status)
		
		ret = MessageBox(NULL, OutMessage, &
											 Boxtitle, messageBox_Icon)
		return
	endif

  endif

END SUBROUTINE sproGetVersion

!****************************************************************************
!
! End of  FUNCTION: sproGetVersion
!
!****************************************************************************


!****************************************************************************
!
!  FUNCTION: sproGetHardLimit ( dlg, id, callbacktype )
!
!  PURPOSE:  This function executes when GetHardLimit  button clicks
!
!  COMMENTS:RNBOsproGetHardLimit API calls here
!
!****************************************************************************

SUBROUTINE sproGetHardLimit( dlg, id, callbacktype )

use dflogm ! include file for Fortarn
  use dfwin ! include header file for fortran
  use SPROEVALGlobals ! file for global variables
  use spromeps_module ! file for API wrappers
  ! use spromeps_constants ! file for Constant and structure defination
  integer(kind=4) :: hardLimit
  character(len=6) :: String_hardlimit
  type (dialog) dlg
  integer id, callbacktype
	include 'resource.fd'
integer messageBox_Icon
  if (callbacktype == dlg_clicked) then
		ret=LoadString( NULL,IDS_GET_HRDLMT,Boxtitle,len(Boxtitle)) 
		messageBox_Icon =  MB_TASKMODAL		
		! RNBOsproGetHardLimit API call
		
		! ***Comment: check whether API get success or not ****
		status = RNBOsproGetHardLimit (RNBOpacket%packet, hardLimit)
	    if (status == 0) then
			ret = LoadString( NULL,IDS_GET_HRDLMT_SUCC,OutMessage,len(OutMessage)) 
			! convert hardlimit value for integer to string
			write (String_hardlimit,'(I6)') hardLimit
			! concat two string
			call Pass_Str(OutMessage,String_hardlimit)
			ret = MessageBox(NULL, OutMessage, &
											 Boxtitle, messageBox_Icon)
			return
		else
	 		ret = LoadString( NULL,IDS_ERR_GET_HRDLMT,OutMessage,len(OutMessage)) 
			write (String_status,'(I3,a)')  status ,'.'
			call Pass_Str(OutMessage,String_status)
			
			ret = MessageBox(NULL, OutMessage, &
											 Boxtitle,messageBox_Icon)
			return
		endif	
  endif

END SUBROUTINE sproGetHardLimit


!****************************************************************************
!
! End of  FUNCTION: sproGetHardLimit
!
!****************************************************************************


!****************************************************************************
!
!  FUNCTION: sproGetFullStatus ( dlg, id, callbacktype )
!
!  PURPOSE:  This function executes when GetFullStatus  button clicks
!
!  COMMENTS:RNBOsproGetFullStatus API calls here
!
!****************************************************************************

SUBROUTINE sproGetFullStatus( dlg, id, callbacktype )
use dflogm ! include file for Fortarn
  use dfwin ! include header file for fortran
  use SPROEVALGlobals ! file for global variables
  use spromeps_module ! file for API wrappers
  ! use spromeps_constants ! file for Constant and structure defination
include 'resource.fd'

  type (dialog) dlg
  integer id, callbacktype
integer messageBox_Icon

  if (callbacktype == dlg_clicked) then
		ret=LoadString( NULL,IDS_GET_FULL_STATUS,Boxtitle,len(Boxtitle)) 
		messageBox_Icon = MB_TASKMODAL		
		! RNBOsproGetFullStatus API call

		status = RNBOsproGetFullStatus(RNBOpacket%packet)
		ret=LoadString( NULL,IDS_GET_FULL_STATUS_SUCC,OutMessage,len(OutMessage)) 
			
		write (String_status,'(I3,A)') status ,'.'
		call Pass_Str(OutMessage,String_status)
		ret = MessageBox(NULL, OutMessage, &
											 Boxtitle, messageBox_Icon)
	 endif

END SUBROUTINE sproGetFullStatus


!****************************************************************************
!
! End of  FUNCTION: sproGetFullStatus
!
!****************************************************************************


!****************************************************************************
!
!  FUNCTION: sproGetKeyInfo ( dlg, id, callbacktype )
!
!  PURPOSE:  This function executes when GetKeyInfo  button clicks
!
!  COMMENTS:GetKeyInfo dialog gets initilaze and sets some default value here
!
!****************************************************************************

SUBROUTINE sproGetKeyInfo( dlg, id, callbacktype )

use dflogm ! include file for Fortarn
  use dfwin ! include header file for fortran
  use SPROEVALGlobals ! file for global variables
  use spromeps_module ! file for API wrappers
  ! use spromeps_constants ! file for Constant and structure defination
  implicit none
  external GetKeyInfo_ONOK
  include 'resource.fd'
  type (dialog) dlg,GetKeyInfo_dlg
  integer id, callbacktype

  if (callbacktype == dlg_clicked) then
		lret = DlgInit(GET_KEY_INFO_DLG, GetKeyInfo_dlg)
			if (lret) then
			! assign key index value 0 initialy
			KeyIndex=0
			!GetKeyInfo_ONOK will call on NextKey button of KeyInfo dialog
			lret = DlgSetSub(GetKeyInfo_dlg, IDOK, GetKeyInfo_ONOK)
			! initialize devid FFFF as default value for keyinfo box
			lret = DlgSet(GetKeyInfo_dlg, IDC_DEVID, "FFFF")
		
			lret = DlgModal(GetKeyInfo_dlg)
		endif
	end if

END SUBROUTINE sproGetKeyInfo


!****************************************************************************
!
! End of  FUNCTION: GetKeyInfo
!
!****************************************************************************


!****************************************************************************
!
!  FUNCTION: sproGetSubLicense ( dlg, id, callbacktype )
!
!  PURPOSE:  This function executes when GetSubLicense  button clicks
!
!  COMMENTS:GetSubLicense dialog gets initilaze  here
!
!****************************************************************************

SUBROUTINE sproGetSubLicense( dlg, id, callbacktype )

use dflogm ! include file for Fortarn
  use dfwin ! include header file for fortran
  use SPROEVALGlobals ! file for global variables
  use spromeps_module ! file for API wrappers
  ! use spromeps_constants ! file for Constant and structure defination
  implicit none
  external GetSubLicenseCellAddress
  external GetSubLicense_ONOK
  include 'resource.fd'
  type (dialog) dlg,GetSubLicense_dlg
  integer id, callbacktype

  if (callbacktype == dlg_clicked) then
		lret = DlgInit(GET_SUB_LIC_DIALOG, GetSubLicense_dlg)
		if (lret) then
			!Set cellAddress value for GetSubLicense Dialog
			lret = DlgSetSub(GetSubLicense_dlg, GET_SUB_LIC_DIALOG, GetSubLicenseCelladdress)
			lret = DlgSetSub(GetSubLicense_dlg, IDOK, GetSubLicense_ONOK)
			lret = DlgModal(GetSubLicense_dlg)
		endif
	end if

END SUBROUTINE sproGetSubLicense


!****************************************************************************
!
! End of  FUNCTION: GetSubLicense
!
!****************************************************************************


!****************************************************************************
!
!  FUNCTION: sproReleaseLicense ( dlg, id, callbacktype )
!
!  PURPOSE:  
!
!  COMMENTS:
!
!****************************************************************************

SUBROUTINE sproReleaseLicense( dlg, id, callbacktype )

use dflogm ! include file for Fortarn
  use dfwin ! include header file for fortran
  use SPROEVALGlobals ! file for global variables
  use spromeps_module ! file for API wrappers
  ! use spromeps_constants ! file for Constant and structure defination
  implicit none
  external ReleaseLicenseCellAddress
  external ReleaseLicense_ONOK
  include 'resource.fd'
  type (dialog) dlg,ReleaseLicense_dlg
  integer id, callbacktype

  if (callbacktype == dlg_clicked) then
		lret = DlgInit(RELEASE_LIC_DIALOG, ReleaseLicense_dlg)
		if (lret) then
			!Set CellAddress value for ReleaseLicense Dialog
			lret = DlgSetSub(ReleaseLicense_dlg, RELEASE_LIC_DIALOG, ReleaseLicenseCelladdress)
			lret = DlgSetSub(ReleaseLicense_dlg, IDOK, ReleaseLicense_ONOK)

			lret = DlgModal(ReleaseLicense_dlg)
		endif
	end if

END SUBROUTINE sproReleaseLicense


!****************************************************************************
!
! End of  FUNCTION: sproReleaseLicense
!
!****************************************************************************


!****************************************************************************
!
!  FUNCTION: sproEnumServer ( dlg, id, callbacktype )
!
!  PURPOSE:  This function executes when EnumServer  button clicks
!
!  COMMENTS:EnumServer dialog gets initilaze and sets default value for DevID and Numserver
!
!****************************************************************************

SUBROUTINE sproEnumServer( dlg, id, callbacktype )
use dflogm ! include file for Fortarn
  use dfwin ! include header file for fortran
  use SPROEVALGlobals ! file for global variables
  use spromeps_module ! file for API wrappers
  ! use spromeps_constants ! file for Constant and structure defination
  implicit none
	external EnumServer_ONOK
  include 'resource.fd'
  type (dialog) dlg,EnumServer_dlg
  integer id, callbacktype

  if (callbacktype == dlg_clicked) then
		lret = DlgInit(ENUM_SRVR_DLG, EnumServer_dlg)
		if (lret) then
				
			lret = DlgSetSub(EnumServer_dlg, IDOK, EnumServer_ONOK)
			!Set default value for DevID
			lret = DlgSet(EnumServer_dlg, IDC_DEVID, "FFFF")
			!set default value for NumServers
			lret = DlgSet(EnumServer_dlg, IDC_NUMSRVRS, "10")
			!Set value for EnmuServerFlag ListBox
			lret = DlgSet (EnumServer_dlg, COMBO_ENSRVR_FLG, 3, DLG_NUMITEMS )
			
			lret = DlgSet (EnumServer_dlg, COMBO_ENSRVR_FLG, "NSPRO_GET_ALL_SERVERS", DLG_STATE )
			lret = DlgSet (EnumServer_dlg, COMBO_ENSRVR_FLG, "NSPRO_GET_ALL_SERVERS", 1 )
			lret = DlgSet (EnumServer_dlg, COMBO_ENSRVR_FLG, "NSPRO_RET_ON_FIRST", 2 )
			lret = DlgSet (EnumServer_dlg, COMBO_ENSRVR_FLG, "NSPRO_RET_ON_FIRST_AVAILABLE", 3 )
			lret = DlgModal(EnumServer_dlg)
		endif
	end if

END SUBROUTINE sproEnumServer


!****************************************************************************
!
! End of  FUNCTION: sproEnumServer
!
!****************************************************************************


!****************************************************************************
!
!  FUNCTION: sproGetContactServer ( dlg, id, callbacktype )
!
!  PURPOSE:  This function executes when GetContactServer  button clicks
!
!  COMMENTS:RNBOsproGetContactServer API calls here.
!
!****************************************************************************

SUBROUTINE sproGetContactServer( dlg, id, callbacktype )

use dflogm ! include file for Fortarn
  use dfwin ! include header file for fortran
  use SPROEVALGlobals ! file for global variables
  use spromeps_module ! file for API wrappers
  ! use spromeps_constants ! file for Constant and structure defination
  implicit none
  external SetContactServer_ONOK
  type (dialog) dlg,ReleaseLicense_dlg
  integer id, callbacktype
  character(len=MAX_NAME_LEN) :: sName
	 include 'resource.fd'
	 integer messageBox_Icon


  if (callbacktype == dlg_clicked) then
		ret=LoadString( NULL,IDS_GET_CON_SRVR,Boxtitle,len(Boxtitle)) 
		
		messageBox_Icon =  MB_TASKMODAL		
		! RNBOsproGetContactServer API call
		status = RNBOsproGetContactServer (RNBOpacket%packet, sName, MAX_NAME_LEN)

		! ***Comment: check whether API get success or not ****		    
		if (status == 0) then
			write (OutMessage,'(A, A)') "GetContactServer successfull. ServerName =", sName
			
			ret = MessageBox(NULL, OutMessage, &
					 Boxtitle, messageBox_Icon)	
		else
	 		ret = LoadString( NULL,IDS_GETCONSRVR_FAIL,OutMessage,len(OutMessage)) 
			write (String_status,'(I3,A)')  status,'.'
			call Pass_Str(OutMessage,String_status)
			
			ret = MessageBox(NULL, OutMessage, &
											 Boxtitle, messageBox_Icon)
			return

		endif	
  endif

  END SUBROUTINE sproGetContactServer


!****************************************************************************
!
! End of  FUNCTION: sproGetContactServer
!
!****************************************************************************


!****************************************************************************
!
!  FUNCTION: sproSetContactServer ( dlg, id, callbacktype )
!
!  PURPOSE:  This function executes when GetContactServer  button clicks
!
!  COMMENTS:
!
!****************************************************************************

SUBROUTINE sproSetContactServer( dlg, id, callbacktype )

use dflogm ! include file for Fortarn
  use dfwin ! include header file for fortran
  use SPROEVALGlobals ! file for global variables
  use spromeps_module ! file for API wrappers
  ! use spromeps_constants ! file for Constant and structure defination

  implicit none
  external SetContactServer_ONOK
  include 'resource.fd'
  type (dialog) dlg,SetContactServer_dlg
  integer id, callbacktype
  
  if (callbacktype == dlg_clicked) then
		lret = DlgInit(SET_CONTACT_SRV_DIALOG, SetContactServer_dlg)
		if (lret) then
			! SetContactServer_ONOK call on click of OK button of this dialog
			lret = DlgSetSub(SetContactServer_dlg, IDOK, SetContactServer_ONOK)
						lret = DlgSet (SetContactServer_dlg, ID_SRV_NAME, 7, DLG_NUMITEMS )
			lret = DlgSet (SetContactServer_dlg, ID_SRV_NAME, "RNBO_STANDALONE", 1 )
			lret = DlgSet (SetContactServer_dlg, ID_SRV_NAME, "RNBO_SPN_DRIVER", 2 )
			lret = DlgSet (SetContactServer_dlg, ID_SRV_NAME, "RNBO_SPN_LOCAL", 3 )
			lret = DlgSet (SetContactServer_dlg, ID_SRV_NAME, "RNBO_SPN_BROADCAST", 4 )
			lret = DlgSet (SetContactServer_dlg, ID_SRV_NAME, "RNBO_SPN_ALL_MODES", 5 )
			lret = DlgSet (SetContactServer_dlg, ID_SRV_NAME, "RNBO_SPN_SERVER_MODES", 6 )
			lret = DlgSet (SetContactServer_dlg, ID_SRV_NAME, "NO-NET", 7 )

			lret = DlgModal(SetContactServer_dlg)
		endif
	end if
END SUBROUTINE sproSetContactServer


!****************************************************************************
!
! End of  FUNCTION: SetContactServer
!
!****************************************************************************


!****************************************************************************
!
!  FUNCTION: keyView ( dlg, id, callbacktype )
!
!  PURPOSE:  This function executes when KeyView  button clicks
!
!
!****************************************************************************

SUBROUTINE KeyView( dlg, id, callbacktype )

use dflogm ! include file for Fortarn
  use dfwin ! include header file for fortran
  use SPROEVALGlobals ! file for global variables
  use spromeps_module ! file for API wrappers
  ! use spromeps_constants ! file for Constant and structure defination
  implicit none
  external KeyView_Update

  include 'resource.fd' ! respource header file for fortran
  type (dialog) dlg,KeyView_dlg
  integer id, callbacktype
   
  
  if (callbacktype == dlg_clicked) then
		
		lret = DlgInit(VIEW_DIALOG, KeyView_dlg)
		if (lret) then
			!KeyView_Update will call at loading time of Key view dialog
			lret = DlgSetSub(KeyView_dlg, VIEW_DIALOG, KeyView_Update)
			!KeyView_Update will call on Update button of KeyView dialog
			lret = DlgSetSub(KeyView_dlg, IDOK, KeyView_Update)
			lret = DlgModal(KeyView_dlg)

		endif
	end if
END SUBROUTINE KeyView


!****************************************************************************
!
! End of  FUNCTION: KeyView
!
!****************************************************************************


!****************************************************************************
!
!  FUNCTION: CompanyInfo ( dlg, id, callbacktype )
!
!  PURPOSE:  This function executes when KeyInfo  button clicks
!
!  COMMENTS:This will just call Company Info dialog.
!
!****************************************************************************

SUBROUTINE CompanyInfo( dlg, id, callbacktype )

use dflogm ! include file for Fortarn
  use dfwin ! include header file for fortran
  use SPROEVALGlobals ! file for global variables
  implicit none

  include 'resource.fd'
  type (dialog) dlg,Info_dlg
  integer id, callbacktype

  if (callbacktype == dlg_clicked) then
		lret = DlgInit(INFO_DIALOG, Info_dlg)
		if (lret) then
				!display  compnay info dialog
			lret = DlgModal(Info_dlg)

		endif
	end if
END SUBROUTINE CompanyInfo


!****************************************************************************
!
! End of  FUNCTION: CompnayInfo
!
!****************************************************************************


!****************************************************************************
!
!  FUNCTION: Help ( dlg, id, callbacktype )
!
!  PURPOSE:  This function executes when Help  button clicks
!
!  COMMENTS:Just give info about Help document of this dialog
!
!****************************************************************************

SUBROUTINE Help( dlg, id, callbacktype )

use dflogm ! include file for Fortarn
  use dfwin ! include header file for fortran
  use SPROEVALGlobals ! file for global variables
  
  implicit none
	include 'resource.fd'
  type (dialog) dlg
  integer id, callbacktype
	integer messageBox_Icon
  if (callbacktype == dlg_clicked) then
			
			ret=LoadString( NULL,IDS_HELP,Boxtitle,len(Boxtitle)) 
					messageBox_Icon =  MB_TASKMODAL		
			! load resource string for help message 
			ret=LoadString( NULL,IDS_MORE_INFO,OutMessage,len(OutMessage)) 
			ret = MessageBox(NULL, OutMessage, &
											 Boxtitle, messageBox_Icon)
			return
  endif

END SUBROUTINE Help


!****************************************************************************
!
! End of  FUNCTION: Help
!
!****************************************************************************

!****************************************************************************
!
!  FUNCTION: FindFirstUnit_ONOK ( dlg, id, callbacktype )
!
!  PURPOSE:  This function executes when Ok buttons of Findfirst dialog clicks
!
!  COMMENTS:RNBOsproFindfirstUnit API calls here.
!
!****************************************************************************
SUBROUTINE FindFirstUnit_ONOK( dlg, id, callbacktype )

  
  USE DFLIB
use dflogm ! include file for Fortarn
  use dfwin ! include header file for fortran
  use SPROEVALGlobals ! file for global variables
  use spromeps_module ! file for API wrappers
  ! use spromeps_constants ! file for Constant and structure defination

  include 'resource.fd'
  character*32   StringdevID 					! string variable for developer ID  
  integer(kind=4) :: devID=0					! developer ID  	
  type (dialog) dlg
  integer id, callbacktype
  integer messageBox_Icon ! variable for message box type and icon symbol

  if (callbacktype == dlg_clicked) then
	
		ret=LoadString( NULL,IDS_FINDFIRST,Boxtitle,len(Boxtitle)) 
		messageBox_Icon =  MB_TASKMODAL		
		! get string value for DevID entered by user
		lret=DLGGET(dlg,FF_ID,StringDevID)
		! get length of string devid
		dataLen=LEN_TRIM(StringDevID)
		
		if (dataLen >0) then	! When DeviD edit box is not blank
			if (dataLen <= VALID_DATA_LENGTH) then	! if DevID is of Valid length
				read (StringDevID, '(Z5)',ERR=100) DevID	!convert hex string to integer
						
				! RNBOsproFindFirstUnit API call
				
		! ***Comment: check whether API get success or not ****						
				status = RNBOsproFindFirstUnit(RNBOpacket%packet,DevID) 
				if(status==0) then
					
					ret = LoadString( NULL,IDS_FF_SUCCESS,OutMessage,len(OutMessage)) 
					ret = MessageBox(NULL,OutMessage , &
					 Boxtitle, messageBox_Icon)
				 	! close dialog after  find first success
					call DlgExit(dlg)
					return
				else
					ret = LoadString( NULL,IDS_ERR_FF_FAILED,OutMessage,len(OutMessage)) 
					
					write (String_status,'(I3,A)')  status ,'.'
					! concat thow string value
					call Pass_Str(OutMessage,String_status)
			
					ret = MessageBox(NULL, OutMessage, &
											 Boxtitle,messageBox_Icon)
					return
				endif
					
 			 else
				! if DevID length is not valid then 
				ret=LoadString(NULL, IDS_INVALID_DEVID, OutMessage, len(OutMessage))
	            ret=MessageBox(NULL, OutMessage, &
					 Boxtitle, messageBox_Icon)
				return
			
			endif
		else
		! if DevID is blank 
			ret=LoadString(NULL, IDS_ERR_NO_DEV_ID, OutMessage, len(OutMessage))
			ret=MessageBox(NULL, OutMessage, &
					 Boxtitle, messageBox_Icon)
			return
		endif
	endif

!if DevID is not valid Hex string then execute this lable
100 	ret=LoadString(NULL, IDS_INVALID_DEVID, OutMessage, len(OutMessage))
	    ret=MessageBox(NULL, OutMessage, &
					 Boxtitle,messageBox_Icon)
		return
  
	END SUBROUTINE FindFirstUnit_ONOK

 
!****************************************************************************
!
! End of  FUNCTION: FindFirstUnit_ONOK
!
!****************************************************************************



!****************************************************************************
!
!  FUNCTION: SetProtocol_ONOK ( dlg, id, callbacktype )
!
!  PURPOSE:  This function executes when Ok button of SetProtocol dialog clicks
!
!  COMMENTS:RNBOsproSetProtocol API calls here.
!
!****************************************************************************

SUBROUTINE SetProtocol_ONOK( dlg, id, callbacktype )

use dflogm ! include file for Fortarn
  use dfwin ! include header file for fortran
  use SPROEVALGlobals ! file for global variables
  use spromeps_module ! file for API wrappers
  ! use spromeps_constants ! file for Constant and structure defination
  include 'resource.fd'
  integer(kind=4) :: ProtocolFlag=0					! protocol flag value
  type (dialog) dlg
  integer id, callbacktype
  integer messageBox_Icon
  if (callbacktype == dlg_clicked) then
	  ret=LoadString( NULL,IDS_SETPROTOCOL,Boxtitle,len(Boxtitle)) 
		messageBox_Icon =  MB_TASKMODAL		
		! get element value for Protocol flag selected
		lret=DLGGETINT(dlg,IDC_CMBPROTOCOL,ProtocolFlag,DLG_STATE)
			
		if (lret ) then ! If Protocol flag value is selected from List box then
			SELECT CASE (ProtocolFlag)
				CASE (1)
					ProtocolFlag = NSPRO_TCP_PROTOCOL
				CASE (2)
					ProtocolFlag = NSPRO_IPX_PROTOCOL
				CASE (3)
					ProtocolFlag = NSPRO_NETBEUI_PROTOCOL
				CASE (4)
					ProtocolFlag = NSPRO_SAP_PROTOCOL
			END SELECT 
			
			
			! RNBOsproSetProtocol API call
			status = RNBOsproSetProtocol(RNBOpacket%packet,ProtocolFlag) 
			
		! ***Comment: check whether API get success or not ****									
			if(status==0) then
				ret = LoadString( NULL,IDS_SETPROTOCOL_SUCC,OutMessage,len(OutMessage)) 
				ret = MessageBox(NULL,OutMessage , &
				      Boxtitle, messageBox_Icon)
				! close Setprotocol dilaog after API success
				call DlgExit(dlg)
				return
			else
				ret = LoadString( NULL,IDS_SETPROTOCOL_FAILED,OutMessage,len(OutMessage)) 
					
				write (String_status,'(I3,A)')  status ,'.'
					call Pass_Str(OutMessage,String_status)
			
					ret = MessageBox(NULL, OutMessage, &
											 Boxtitle, messageBox_Icon)
				return
			endif
		else
			! If Protocol flag value is not selected from ComboBox then 
			ret = MessageBox(NULL, "Select protocolFlag value."C, &
						 Boxtitle, messageBox_Icon)
			return

		endif
	endif

  END SUBROUTINE SetProtocol_ONOK


!****************************************************************************
!
! End of  FUNCTION: SetProtocol_ONOK
!
!****************************************************************************



!****************************************************************************
!
!  FUNCTION: SetHeartBeat( dlg, id, callbacktype )
!
!  PURPOSE:  This function executes when Ok button of SetHeartBeat dialog clicks
!
!  COMMENTS:RNBOsproSetHeartBeat API calls here.
!
!****************************************************************************

SUBROUTINE SetHeartBeat_ONOK( dlg, id, callbacktype )

use dflogm ! include file for Fortarn
  use dfwin ! include header file for fortran
  use SPROEVALGlobals ! file for global variables
  use spromeps_module ! file for API wrappers
  ! use spromeps_constants ! file for Constant and structure defination
  include 'resource.fd'
  integer(kind=4) :: HeartBeat=0 				! heartBeat integer variable
  Character*32 :: String_HeartBeat				! heartBeat string variable
  type (dialog) dlg
  integer id, callbacktype
  integer messageBox_Icon
  if (callbacktype == dlg_clicked) then
		ret=LoadString( NULL,IDS_SET_HEARTBEAT,Boxtitle,len(Boxtitle)) 
		messageBox_Icon = MB_TASKMODAL	
		
		! get heartbeat value as string from Edit box	
		lret=DLGGET(dlg,HEARTBEAT_EDIT,String_HeartBeat)
		! get length of heart beat string
		dataLen=LEN_TRIM(String_HeartBeat)
		if (dataLen >0) then ! IF setHeartBeat is not blank 
			read (String_HeartBeat, '(I8)', ERR=100) HeartBeat ! convert string to Long Int  
			if (HeartBeat <MIN_HEARTBEAT .OR. HeartBeat >MAX_HEARTBEAT) then ! Check limit for heart beat value
				! if heart beat value is not within range of MAX and min value then 
				if (HeartBeat <> INFINITE_HEARTBEAT) then ! if heartBeat value = -1 then
					! if heart beat value is not valid for INFINITE heart beat
				 	ret=LoadString(NULL, IDS_ERR_INVALID_SETHERATBEAT_VALUE, OutMessage, len(OutMessage))
					ret=MessageBox(NULL, OutMessage, &
												 Boxtitle,messageBox_Icon)
					return

				else				
					
					! RNBOsproSetHeartBeat API call

		! ***Comment: check whether API get success or not ****						
					status = RNBOsproSetHeartBeat(RNBOpacket%packet,HeartBeat) 
					if(status==0) then
						ret=LoadString( NULL,IDS_SETHEARTBEAT_SUCC,OutMessage,len(OutMessage)) 
						ret = MessageBox(NULL, OutMessage, &
													 Boxtitle, messageBox_Icon)
						! close dialog after API success
						call DlgExit(dlg)
						return
					else
						ret=LoadString( NULL,IDS_SETHEARTBEAT_FAILED,OutMessage,len(OutMessage)) 
						
							
						write (String_status,'(I3,A)')  status ,'.'
						call Pass_Str(OutMessage,String_status)
			
						ret = MessageBox(NULL, OutMessage, &
											 Boxtitle, messageBox_Icon)
						return
					endif
				endif
			else				
				! if heart value is within limit of MAXIMUM and MINIMUM heart beat value.
				status = RNBOsproSetHeartBeat(RNBOpacket%packet,HeartBeat) 
				
				! ***Comment: check whether API get success or not ****						
				if(status==0) then
					ret=LoadString( NULL,IDS_SETHEARTBEAT_SUCC,OutMessage,len(OutMessage)) 
					ret = MessageBox(NULL, OutMessage, &
														 Boxtitle, messageBox_Icon)
					! close dialog after success
					call DlgExit(dlg)
					return
				else
					ret=LoadString( NULL,IDS_SETHEARTBEAT_FAILED,OutMessage,len(OutMessage)) 
					write (String_status,'(I3,A)')  status ,'.'
					call Pass_Str(OutMessage,String_status)
					ret = MessageBox(NULL, OutMessage, &
													 Boxtitle, messageBox_Icon)
					return
				endif
			endif	
		else
			!If heartBeat value is blank
			ret=LoadString(NULL, IDS_ERR_NO_SETHERATBEAT_VALUE, OutMessage, len(OutMessage))
	    ret=MessageBox(NULL, OutMessage, &
					 Boxtitle, messageBox_Icon)
			return
		endif
  endif
! if heartValue is Invalid integer string  then exception handels
100 	ret=LoadString(NULL, IDS_ERR_INVALID_SETHERATBEAT_VALUE, OutMessage, len(OutMessage))
	    ret=MessageBox(NULL, OutMessage, &
					 Boxtitle,messageBox_Icon)
		return

  END SUBROUTINE SetHeartBeat_ONOK

!****************************************************************************
!
! End of  FUNCTION: SetHeartBeat_ONOK
!
!****************************************************************************

!****************************************************************************
!
!  FUNCTION: ReadCellAddress ( dlg, id, callbacktype )
!
!  PURPOSE:  This function executes during initialization of Read dialog 
!
!  COMMENTS:Sets CellAddress List box value.
!
!****************************************************************************

SUBROUTINE ReadCellAddress( dlg, id, callbacktype )

use dflogm ! include file for Fortarn
  use dfwin ! include header file for fortran
  use SPROEVALGlobals ! file for global variables
  use spromeps_module ! file for API wrappers
  ! use spromeps_constants ! file for Constant and structure defination
  implicit none
  include 'resource.fd'
  character*2 :: cellAdd ! variable for cell address
  integer(kind=1) :: a ! loop variable
  type (dialog) dlg
  integer id, callbacktype
 ! loop to write 64 cell address value in ListBox
	lret = DlgSet (dlg, RD_ID, 64, DLG_NUMITEMS )
	DO a = 0, 63
		! calculate Hex value for cell address
		write (cellAdd,'(Z2.2)')  a
		! write cell address in list box
		lret = DlgSet (dlg, RD_ID,cellAdd , a+1)
	end do		
	
END SUBROUTINE ReadCellAddress


!****************************************************************************
!
! End of  FUNCTION: ReadCellAddress
!
!****************************************************************************



!****************************************************************************
!
!  FUNCTION: Read_ONOK ( dlg, id, callbacktype )
!
!  PURPOSE:  This function executes when Ok button of Read dialog clicks
!
!  COMMENTS:RNBOsproRead API calls here.
!
!****************************************************************************

SUBROUTINE read_ONOK( dlg, id, callbacktype )

use dflogm ! include file for Fortarn
  use dfwin ! include header file for fortran
  use SPROEVALGlobals ! file for global variables
  use spromeps_module ! file for API wrappers
  ! use spromeps_constants ! file for Constant and structure defination
  include 'resource.fd'
  integer(kind=2) :: cellAddress				! cell Address
  Character*4 :: String_cellAddress				! cell Address string variable
  integer(kind=4) :: OutData					! data to read
  Character*4 :: String_OutData					! data to read string variable 
  type (dialog) dlg
  integer id, callbacktype
  integer messageBox_Icon
  if (callbacktype == dlg_clicked) then
		ret=LoadString( NULL,IDS_READ,Boxtitle,len(Boxtitle)) 	
		messageBox_Icon =  MB_TASKMODAL		
		! get cell address value selected 
		lret=DLGGET(dlg,RD_ID,String_cellAddress)

		if (lret) then ! if some value is selected for cell address then
		! If Cell address value is selected then convert into integer
			read (String_cellAddress, '(Z2)') cellAddress  
			
			! RNBOsproRead API call
			status = RNBOsproRead(RNBOpacket%packet,cellAddress,Outdata) 
			
			! ***Comment: check whether API get success or not ****						
			if(status==0) then
				! convert int data value to string for display 
				write (String_OutData, '(Z4.4)') OutData  
				! display read data value in dialog box
				lret=DLGSET(dlg,RD_VAL,String_OutData)
			else
				ret=LoadString(NULL, IDS_ERR_READ_FAILED, OutMessage, len(OutMessage))
		        write (String_status,'(I3,A)')  status ,'.'
				call Pass_Str(OutMessage,String_status)
			
				ret = MessageBox(NULL, OutMessage, &
									 Boxtitle, messageBox_Icon)
				return			
	
			endif	
		else ! is CellAddress is not selected then
			ret=LoadString(NULL, IDS_ERR_NO_ADDR, OutMessage, len(OutMessage))
			ret=MessageBox(NULL, OutMessage, &
					  					 Boxtitle,messageBox_Icon)
			return
	  endif
	endif

  END SUBROUTINE Read_ONOK

!****************************************************************************
!
! End of  FUNCTION: Winmain
!
!****************************************************************************
!****************************************************************************
!
!  FUNCTION: XreadCellAddress ( dlg, id, callbacktype )
!
!  PURPOSE:  This function executes during initialization of Xread dialog 
!
!  COMMENTS:Sets CellAddress List box value.
!
!****************************************************************************

SUBROUTINE XreadCellAddress( dlg, id, callbacktype )

use dflogm ! include file for Fortarn
  use dfwin ! include header file for fortran
  use SPROEVALGlobals ! file for global variables
  use spromeps_module ! file for API wrappers
  ! use spromeps_constants ! file for Constant and structure defination
  implicit none
  include 'resource.fd'
  character*2 :: cellAdd ! variable for cell address
  integer(kind=1) :: a ! loop variable
  type (dialog) dlg
  integer id, callbacktype
  ! loop for writing 64 cell address value in lIstBox
  lret = DlgSet (dlg, XR_ID, 64, DLG_NUMITEMS )
	DO a = 0, 63
		! calculate hex value for cell address
		write (cellAdd,'(Z2.2)')  a
		! write cell address value in list box
		lret = DlgSet (dlg, XR_ID,cellAdd , a+1)
	end do		

	
END SUBROUTINE XreadCellAddress


!****************************************************************************
!
! End of  FUNCTION: XreadCellAddress
!
!****************************************************************************


!****************************************************************************
!
!  FUNCTION: Xread_ONOK ( dlg, id, callbacktype )
!
!  PURPOSE:  This function executes when Ok button of XRead dialog clicks
!
!  COMMENTS:RNBOsproExtendedRead API calls here.
!
!****************************************************************************


SUBROUTINE Xread_ONOK( dlg, id, callbacktype )

use dflogm ! include file for Fortarn
  use dfwin ! include header file for fortran
  use SPROEVALGlobals ! file for global variables
  use spromeps_module ! file for API wrappers
  ! use spromeps_constants ! file for Constant and structure defination
  include 'resource.fd'
  integer(kind=2) :: cellAddress				! cell Address
  Character*4 :: String_cellAddress				! string variable for cell data
  integer(kind=4) :: OutData					!Outputdata
  Character*4 :: String_OutData					!Outputdata string variable for display
  integer(kind=1) :: accessCode = 0				! accessCode
  Character*4 :: String_AccessCode				! accessCode string variable
  type (dialog) dlg
  integer id, callbacktype
  integer messageBox_Icon
  if (callbacktype == dlg_clicked) then
	
		ret=LoadString( NULL,IDS_XREAD,Boxtitle,len(Boxtitle)) 	
		messageBox_Icon =  MB_TASKMODAL		
	    ! get cell address value
		lret=DLGGET(dlg,XR_ID,String_cellAddress)
		if (lret) then ! if cell address is selected then
			read (String_cellAddress, '(Z2)') cellAddress  !convert celladdress into integer

			! RNBOsproExtendedRead API call
			status = RNBOsproExtendedRead(RNBOpacket%packet,cellAddress,Outdata,accessCode) 
		! ***Comment: check whether API get success or not ****									
			if(status==0) then
				!convert data value into string
				write (String_OutData, '(Z4.4)') OutData  
				!display data read in dialog box
				lret=DLGSET(dlg,XR_VAL,String_OutData)
				!convert accesscode value into string
				write (String_accessCode, '(Z2)') accessCode  
				! display access code of data read in dialog box
				lret=DLGSET(dlg,XR_AC,String_accessCode)
			else

				ret=LoadString(NULL, IDS_ERR_XREAD_FAILED, OutMessage, len(OutMessage))
				write (String_status,'(I3,A)')  status ,'.'
				call Pass_Str(OutMessage,String_status)
				ret = MessageBox(NULL, OutMessage, &
								 Boxtitle, messageBox_Icon)
				return			
	
			endif	
		else !if cell address blank then
			ret=LoadString(NULL, IDS_ERR_NO_ADDR, OutMessage, len(OutMessage))
			ret=MessageBox(NULL, OutMessage, &
					  					 Boxtitle, messageBox_Icon)
			return
		endif
  endif 
  END SUBROUTINE Xread_ONOK

!****************************************************************************
!
! End of  FUNCTION: Xread_ONOK
!
!****************************************************************************



!****************************************************************************
!
!  FUNCTION: WriteCellAddress ( dlg, id, callbacktype )
!
!  PURPOSE:  This function executes during initialization of Write dialog 
!
!  COMMENTS:Sets CellAddress and accessCode List box value.
!
!****************************************************************************
SUBROUTINE WriteCellAddress( dlg, id, callbacktype )

use dflogm ! include file for Fortarn
  use dfwin ! include header file for fortran
  use SPROEVALGlobals ! file for global variables
  use spromeps_module ! file for API wrappers
  ! use spromeps_constants ! file for Constant and structure defination
  implicit none
  include 'resource.fd'
 character*2 :: cellAdd ! variable for cell address
  integer(kind=1) :: a ! loop variable
  type (dialog) dlg
  integer id, callbacktype
  ! loop for writing 64 cell address value in lIstBox
 	lret = DlgSet (dlg, WR_ID, 64, DLG_NUMITEMS )
	DO a = 0, 63
		! calculate hex value for cell address
		write (cellAdd,'(Z2.2)')  a
		! write cell address value in list box
		lret = DlgSet (dlg, WR_ID,cellAdd , a+1)
	end do		
	
	lret = DlgSet (dlg, WR_AC, 4, DLG_NUMITEMS )
	! loop for writing 3 accesscode value in lIstBox
	DO a = 0, 3
		
		write (cellAdd,'(I2)')  a
		
		lret = DlgSet (dlg, WR_AC,cellAdd , a+1)
	end do	
	
END SUBROUTINE WriteCellAddress

!****************************************************************************
! End of  FUNCTION: WriteCellAddress
!
!****************************************************************************

!****************************************************************************
!
!  FUNCTION: Write_ONOK ( dlg, id, callbacktype )
!
!  PURPOSE:  This function executes on OK buttons clicks of Read dialog 
!
!  COMMENTS:RNBOsproWrite API calls here.
!
!****************************************************************************

SUBROUTINE Write_ONOK( dlg, id, callbacktype )

use dflogm ! include file for Fortarn
  use dfwin ! include header file for fortran
  use SPROEVALGlobals ! file for global variables
  use spromeps_module ! file for API wrappers
  ! use spromeps_constants ! file for Constant and structure defination
  include 'resource.fd'
  
  integer(kind=2) :: cellAddress				! cell Address
  Character*4 :: String_cellAddress				! string variable for cell address
  integer(kind=4) :: writeData					! data to be written
  Character*32 :: String_writeData				! string variable for data to be written
  integer(kind=2) :: accessCode					! access code variable	
  Character*2 :: String_AccessCode				! string variable for access code
	integer messageBox_Icon  

  type (dialog) dlg
  integer id, callbacktype
  
  if (callbacktype == dlg_clicked) then
		ret=LoadString( NULL,IDS_WRITE,Boxtitle,len(Boxtitle)) 	
		messageBox_Icon =  MB_TASKMODAL		
		! get cell address value selected by user
		lret=DLGGET(dlg,WR_ID,String_cellAddress)
		if (lret) then ! if cell address selected then
			read (String_cellAddress, '(Z2)',ERR=100) cellAddress   !convert into integer
			! get write password as string
			lret=DLGGET(dlg,WR_PW,String_writePassword)
			! get length of write password
			dataLen=LEN_TRIM(String_writePassword)
			
			if (dataLen >0) then !if write password is not blank then
				if (dataLen <= VALID_DATA_LENGTH) then ! ckeck length of write password string 
					read (String_writePassword, '(Z4)',ERR=110) writePassword  !conver hex string to 
					! get access code value as string
					lret=DLGGET(dlg,WR_AC,String_accessCode)
					if (lret) then ! is access code selected then 
						read (String_accessCode, '(Z2)',ERR=120) accessCode ! Hex string to integer
						lret=DLGGET(dlg,WR_VAL,String_writeData)
						dataLen=LEN_TRIM(String_writeData)
						if (dataLen >0) then ! if data to be write is entered then 
							if (dataLen <= VALID_DATA_LENGTH) then
								read (String_writeData, '(Z4)',ERR=130) writeData ! Hex string to integer
								
								! RNBOsproWrite API call
								status = RNBOsproWrite(RNBOpacket%packet,writePassword,cellAddress,writeData,&
																			 accessCode) 
								
								! ***Comment: check whether API get success or not ****						
								if(status==0) then
									ret = LoadString(NULL,IDS_WRITE_SUCCESS,OutMessage,len(OutMessage)) 
									ret = MessageBox(NULL, OutMessage, &
																	 Boxtitle, messageBox_Icon)
									return
								else
									ret = LoadString( NULL,IDS_ERR_WRITE_FAILED,OutMessage,len(OutMessage)) 
									write (String_status,'(I3,A)')  status ,'.'
									call Pass_Str(OutMessage,String_status)
			
									ret = MessageBox(NULL, OutMessage, &
											 Boxtitle, messageBox_Icon)
									return
								endif
							else
								! if Invalid data to be write then 
								ret=LoadString(NULL, IDS_ERR_INVALID_WRITE_INPUT, OutMessage, len(OutMessage))
								ret=MessageBox(NULL, OutMessage, &
							  								Boxtitle, messageBox_Icon)
								return
							endif
						else
							! if data to be write is blank then 
							ret=LoadString(NULL, IDS_ERR_NO_WRITE_VALUE, OutMessage, len(OutMessage))
							ret=MessageBox(NULL, OutMessage, &
							  					 Boxtitle, messageBox_Icon)
							return
						endif
					else
						! if access code is not selected then
						ret=LoadString(NULL, IDS_ERR_NO_ACCESS_CODE, OutMessage, len(OutMessage))
						ret=MessageBox(NULL, OutMessage, &
							  					 Boxtitle,messageBox_Icon)
						return
					endif
				else
					! if invalid write password then 
					ret=LoadString(NULL,IDS_ERR_INVALID_WRITE_PASSWORD, OutMessage, len(OutMessage))
					ret=MessageBox(NULL, OutMessage, &
  			  								Boxtitle,messageBox_Icon)
					return
				endif
			else
				! if write password is blank then
				ret=LoadString(NULL, IDS_ERR_NO_WRITE_PASSWORD, OutMessage, len(OutMessage))
				ret=MessageBox(NULL, OutMessage, &
					  					 Boxtitle,messageBox_Icon)
				return
			endif
		else
			! if cell address is not selected
			ret=LoadString(NULL, IDS_ERR_NO_ADDR, OutMessage, len(OutMessage))
			ret=MessageBox(NULL, OutMessage, &
					  					 Boxtitle,messageBox_Icon)
			return
		endif
	endif

! if cell address is invalid
100 	ret=LoadString(NULL, IDS_INVALID_ADDR, OutMessage, len(OutMessage))
	    ret=MessageBox(NULL, OutMessage, &
					 Boxtitle,messageBox_Icon)
		  return

! if write password is not valid hex string
110 	ret=LoadString(NULL, IDS_ERR_INVALID_WRITE_PASSWORD, OutMessage, len(OutMessage))
	    ret=MessageBox(NULL, OutMessage, &
					 Boxtitle, messageBox_Icon)
		return

! if Access code is not valid 
120 	ret=LoadString(NULL, IDS_INVALID_ACC_CODE, OutMessage, len(OutMessage))
	    ret=MessageBox(NULL, OutMessage, &
					 Boxtitle, messageBox_Icon)
		  return

! if data to be write is not valid hex string
130 	ret=LoadString(NULL, IDS_ERR_INVALID_WRITE_INPUT, OutMessage, len(OutMessage))
	    ret=MessageBox(NULL, OutMessage, &
					 Boxtitle, messageBox_Icon)

  END SUBROUTINE Write_ONOK
								
						
!****************************************************************************
!
! End of  FUNCTION: Write_ONOK
!
!****************************************************************************



!****************************************************************************
!
!  FUNCTION: OverwriteCellAddress ( dlg, id, callbacktype )
!
!  PURPOSE:  This function executes during initialization of Overwrite dialog 
!
!  COMMENTS:Sets CellAddress and accessCode List box value.
!
!****************************************************************************

SUBROUTINE OverwriteCellAddress( dlg, id, callbacktype )

use dflogm ! include file for Fortarn
  use dfwin ! include header file for fortran
  use SPROEVALGlobals ! file for global variables
  use spromeps_module ! file for API wrappers
  ! use spromeps_constants ! file for Constant and structure defination
  implicit none
  include 'resource.fd'
  character*2 :: cellAdd
  integer(kind=1) :: a

  type (dialog) dlg
  integer id, callbacktype
! loop for writing cell address in list box
	lret = DlgSet (dlg, OW_ID, 64, DLG_NUMITEMS )
	DO a = 0, 63
		write (cellAdd,'(Z2.2)')  a
			
		lret = DlgSet (dlg, OW_ID,cellAdd , a+1)
	end do		
! loop for writing access code value in list box
 	lret = DlgSet (dlg, OW_AC, 4, DLG_NUMITEMS )
	DO a = 0, 3
		write (cellAdd,'(I2)')  a
			
		lret = DlgSet (dlg, OW_AC,cellAdd , a+1)
	end do		


	
END SUBROUTINE OverwriteCellAddress


!****************************************************************************
!
! End of  FUNCTION: OverwriteCellAddress
!
!****************************************************************************



!****************************************************************************
!
!  FUNCTION: Overwrite_ONOK ( dlg, id, callbacktype )
!
!  PURPOSE:  This function executes on OK buttons clicks of Overwrite dialog 
!
!  COMMENTS:RNBOsproOverwrite API calls here.
!
!****************************************************************************

SUBROUTINE Overwrite_ONOK( dlg, id, callbacktype )

use dflogm ! include file for Fortarn
  use dfwin ! include header file for fortran
  use SPROEVALGlobals ! file for global variables
  use spromeps_module ! file for API wrappers
  ! spromeps_constants ! file for Constant and structure defination
  include 'resource.fd'
  integer(kind=2) :: cellAddress				! cell Address
  Character*4 :: String_cellAddress			! string variable for cell address
  integer(kind=4) :: writeData				! data to be written
  Character*32 :: String_writeData		! string variable for data to be written
  integer(kind=2) :: accessCode
  Character*2 :: String_AccessCode
  type (dialog) dlg
  integer id, callbacktype
  integer messageBox_Icon
  
  if (callbacktype == dlg_clicked) then
		ret=LoadString( NULL,IDS_OVERWRITE,Boxtitle,len(Boxtitle)) 	
		messageBox_Icon =  MB_TASKMODAL		
		lret=DLGGET(dlg,OW_ID,String_cellAddress)
		if (lret) then  ! if cell address selected then
			read (String_cellAddress, '(Z2)',ERR=100) cellAddress  ! hex string to integer
			lret=DLGGET(dlg,OW_PW_3,String_writePassword) ! check for valid write password
			dataLen=LEN_TRIM(String_writePassword)
			if (dataLen >0) then
				if (dataLen <= VALID_DATA_LENGTH) then
					read (String_writePassword, '(Z4)',ERR=110) writePassword  ! convert string to int
					lret=DLGGET(dlg,OW_PW_1,String_OW1Password)
					dataLen=LEN_TRIM(String_OW1Password) ! check for valid Overwrite password1
					if (dataLen >0) then
						if (dataLen <= VALID_DATA_LENGTH) then
							read (String_OW1Password, '(Z4)',ERR=140) OW1Password  ! convert string to int					
							lret=DLGGET(dlg,OW_PW_2,String_OW2Password)
							dataLen=LEN_TRIM(String_OW2Password)
							if (dataLen >0) then !	check for valid Overwrite password2
								if (dataLen <= VALID_DATA_LENGTH) then
									read (String_OW2Password, '(Z4)',ERR=150) OW2Password  ! convert string to int					
									lret=DLGGET(dlg,OW_AC,String_accessCode)
									if (lret) then
										read (String_accessCode, '(Z2)',ERR=120) accessCode ! convert string to int
										lret=DLGGET(dlg,OW_VAL,String_writeData)
										dataLen=LEN_TRIM(String_writeData)
										if (dataLen >0) then ! check for valid data to be write
											if (dataLen <= VALID_DATA_LENGTH) then
												read (String_writeData, '(Z4)',ERR=130) writeData ! convert string to int
												
												
												! RNBOsproOverwrite API call
												status = RNBOsproOverwrite(RNBOpacket%packet,writePassword,OW1Password,&
																									 OW2Password,cellAddress,writeData,accessCode) 
												
												! ***Comment: check whether API get success or not ****						
												if(status==0) then
													ret = LoadString(NULL,IDS_OVERWRITE_SUCCESS,OutMessage,len(OutMessage)) 
													ret = MessageBox(NULL, OutMessage, &
																	 Boxtitle,messageBox_Icon)
													return
												else
													ret = LoadString( NULL,IDS_ERR_OVERWRITE_FAILED,OutMessage,len(OutMessage)) 
													write (String_status,'(I3,A)')  status ,'.'
													call Pass_Str(OutMessage,String_status)
			
													ret = MessageBox(NULL, OutMessage, &
																	Boxtitle,messageBox_Icon)
													return
												endif
											else ! if data value is invalid 
												ret=LoadString(NULL, IDS_ERR_INVALID_WRITE_INPUT, OutMessage,&
																			 len(OutMessage))
												ret=MessageBox(NULL, OutMessage, &
							  								Boxtitle,messageBox_Icon)
												return
											endif
										else ! if data to be written is blank
											ret=LoadString(NULL, IDS_ERR_NO_WRITE_VALUE, OutMessage, len(OutMessage))
											ret=MessageBox(NULL, OutMessage, &
							  									 Boxtitle, messageBox_Icon)
											return
										endif
									else ! if access code is not selected
										ret=LoadString(NULL, IDS_ERR_NO_ACCESS_CODE, OutMessage, len(OutMessage))
										ret=MessageBox(NULL, OutMessage, &
							  									 Boxtitle, messageBox_Icon)
										return
									endif
								else ! if overwrite password value is invalid
									ret=LoadString(NULL,IDS_ERR_INVALID_OVERWRITE2_PASSWORD, OutMessage,&
																 len(OutMessage))
									ret=MessageBox(NULL, OutMessage, &
  			  								Boxtitle,messageBox_Icon)
									return
								endif
							else ! if if overwrite password is blank
								ret=LoadString(NULL, IDS_ERR_NO_OVERWRITE2_PASSWORD, OutMessage, len(OutMessage))
								ret=MessageBox(NULL, OutMessage, &
					  									 Boxtitle, messageBox_Icon)
								return
							endif		
						else ! if overwrite password value is invalid
							ret=LoadString(NULL,IDS_ERR_INVALID_OVERWRITE1_PASSWORD, OutMessage,&
														 len(OutMessage))
							ret=MessageBox(NULL, OutMessage, &
  			  								Boxtitle, messageBox_Icon)
							return
						endif
					else ! if overwrite password value is blank
						ret=LoadString(NULL, IDS_ERR_NO_OVERWRITE1_PASSWORD, OutMessage, len(OutMessage))
						ret=MessageBox(NULL, OutMessage, &
					  					 Boxtitle,messageBox_Icon)
						return
					endif
				else ! if write password value is invalid
					ret=LoadString(NULL,IDS_ERR_INVALID_WRITE_PASSWORD, OutMessage, len(OutMessage))
					ret=MessageBox(NULL, OutMessage, &
  			  								Boxtitle, messageBox_Icon)
					return
				endif
			else ! if write password value is blank
				ret=LoadString(NULL, IDS_ERR_NO_WRITE_PASSWORD, OutMessage, len(OutMessage))
				ret=MessageBox(NULL, OutMessage, &
					  					 Boxtitle, messageBox_Icon)
				return
			endif
			else ! if celladdress is not selected
			ret=LoadString(NULL, IDS_ERR_NO_ADDR, OutMessage, len(OutMessage))
			ret=MessageBox(NULL, OutMessage, &
					  					 Boxtitle, messageBox_Icon)
			return
		endif
	endif

! if cwll address is invalid hex value
100 	ret=LoadString(NULL, IDS_INVALID_ADDR, OutMessage, len(OutMessage))
	    ret=MessageBox(NULL, OutMessage, &
					 Boxtitle, messageBox_Icon)
		  return
! if write password is invalid hex value
110 	ret=LoadString(NULL, IDS_ERR_INVALID_WRITE_PASSWORD, OutMessage, len(OutMessage))
	    ret=MessageBox(NULL, OutMessage, &
					 Boxtitle, messageBox_Icon)
		return
! if accesscode is invalid hex value
120 	ret=LoadString(NULL, IDS_INVALID_ACC_CODE, OutMessage, len(OutMessage))
	    ret=MessageBox(NULL, OutMessage, &
					 Boxtitle,  messageBox_Icon)
		  return
! if data is invalid hex value
130 	ret=LoadString(NULL, IDS_ERR_INVALID_WRITE_INPUT, OutMessage, len(OutMessage))
	    ret=MessageBox(NULL, OutMessage, &
					 Boxtitle,  messageBox_Icon)
			return
! if overwrite password1 is invalid hex value
140 	ret=LoadString(NULL, IDS_ERR_INVALID_OVERWRITE1_PASSWORD, OutMessage, len(OutMessage))
	    ret=MessageBox(NULL, OutMessage, &
					 Boxtitle, messageBox_Icon)
		  return
! if overwrite paswword2 is invalid hex value
150 	ret=LoadString(NULL, IDS_ERR_INVALID_OVERWRITE2_PASSWORD, OutMessage, len(OutMessage))
	    ret=MessageBox(NULL, OutMessage, &
					 Boxtitle, messageBox_Icon)


  END SUBROUTINE Overwrite_ONOK

!****************************************************************************
!
!   END SUBROUTINE Overwrite_ONOK
!
!****************************************************************************






!****************************************************************************
!
!  FUNCTION: QueryCellAddress ( dlg, id, callbacktype )
!
!  PURPOSE:  This function executes during initialization of Query dialog 
!
!  COMMENTS:Sets CellAddress List box value.
!
!****************************************************************************

SUBROUTINE QueryCellAddress( dlg, id, callbacktype )

use dflogm ! include file for Fortarn
  use dfwin ! include header file for fortran
  use SPROEVALGlobals ! file for global variables
  use spromeps_module ! file for API wrappers
! spromeps_constants ! file for Constant and structure defination
  implicit none
  include 'resource.fd'
  character*2 :: cellAdd
  integer(kind=1) :: a

  type (dialog) dlg
  integer id, callbacktype
! loop for cell address
	lret = DlgSet (dlg, QRY_ID, 64, DLG_NUMITEMS )
	DO a = 0, 63
		write (cellAdd,'(Z2.2)')  a
		
		lret = DlgSet (dlg, QRY_ID,cellAdd , a+1)
	end do		
   
  	
END SUBROUTINE QueryCellAddress


!****************************************************************************
!
! End of  FUNCTION: QueryCellAddress
!
!****************************************************************************



!****************************************************************************
!
!  FUNCTION: Query_ONOK ( dlg, id, callbacktype )
!
!  PURPOSE:  This function executes on OK buttons clicks of Query dialog 
!
!  COMMENTS:RNBOsproQuery API calls here.
!
!****************************************************************************

SUBROUTINE Query_ONOK( dlg, id, callbacktype )

use dflogm ! include file for Fortarn
  use dfwin ! include header file for fortran
  use SPROEVALGlobals ! file for global variables
  use spromeps_module ! file for API wrappers
  ! use spromeps_constants ! file for Constant and structure defination
  include 'resource.fd'
  integer(kind=2) :: cellAddress				! cell Address
  Character*4 :: String_cellAddress      ! string variuab;e for cell address
  character(kind=1), Allocatable  :: queryData(:) ! dynamic array for input query data
  Character*128   :: String_queryData	! string variable for query data
  Character(len=128) ::String_outputQueryData	!string variable for query response
  Character(len=8) ::String_outputQueryData32	! string variable for queryresponse32
  
  integer(kind=1), Allocatable :: response (:) ! dynamic array for query response
  Character(len=56) :: String_response  ! 
  integer(kind=4) :: response32 ! Output response32 from API
  integer(kind=4) :: QyeryDataLen ! variable for query data length
  integer(kind=1) :: validquerydata	! varaibe for validity of input query data
  type (dialog) dlg
  integer id, callbacktype,i,j
  integer messageBox_Icon
  String_outputQueryData='' ! blank value assign to string
  String_outputQueryData32='' ! blank value assign to string
    messageBox_Icon =  MB_TASKMODAL
				if (callbacktype == dlg_clicked) then
	
			ret=LoadString( NULL,IDS_QUERY,Boxtitle,len(Boxtitle)) 	
			!get cell address value
			lret=DLGGET(dlg,QRY_ID,String_cellAddress) ! if cell address selected then
			if(lret) then
				read (String_cellAddress, '(Z2)',ERR=100) cellAddress  !Hex to integer
				! get query data value
				lret=DLGGET(dlg,QRY_QS,String_queryData)
				! get length of query data
				dataLen=LEN_TRIM(String_queryData)

				if (dataLen >0) then ! check for valid query input data
					if (dataLen >= MIN_QYERYDATA_LENGTH .AND. dataLen <= (MAX_QUERYDATA_LENGTH*2) ) then ! ceck length for query data
						if ((Mod(dataLen,2)) == 0) then ! check for even length of query data

							allocate(queryData(dataLen/2)) ! dynamically allocate array
							allocate(response(dataLen/2))
							! call subroutine to check valid hex query and  convert string query data to integer array
							call ConvertBufferToHex(String_queryData,queryData,dataLen,validquerydata)						
							if (validquerydata == 0) then  ! if eneterd query data is not valid hex string then 
								! if input query is in valid hex string
								ret=LoadString(NULL, IDS_ERR_INVALID_QUERY_DATA, OutMessage, len(OutMessage))
								ret=MessageBox(NULL, OutMessage, &
								 Boxtitle, messageBox_Icon)
								return
							end if

						
						! RNBOsproQuery API call
						status = RNBOsproQuery(RNBOpacket%packet,cellAddress , queryData, response,&
																	 response32, dataLen/2)
						
						! ***Comment: check whether API get success or not ****						
						if(status==0) then
							ret = LoadString(NULL,IDS_ERR_QUERY_SUCC,OutMessage,len(OutMessage)) 
							ret = MessageBox(NULL, OutMessage, &
											 Boxtitle, messageBox_Icon)
							! reset variable for next time of API call
							validquerydata=0	
							! call subroutine to convert output query response into valid hex string
							call ConvertHexTochar(response,String_outputQueryData,dataLen)
							! convert response 32 into valid hex string
							write (String_outputQueryData32,'(Z8)')  response32
							! display output from Query API into query dialog for user
							lret=DLGSET(dlg,QRY_RSLT,String_outputQueryData)
							lret=DLGSET(dlg,QRY_RSLT_32,String_outputQueryData32)

							return
						else
							ret = LoadString( NULL,IDS_ERR_QUERY_FAILED,OutMessage,len(OutMessage)) 
							write (String_status,'(I3,A)')  status ,'.'
							call Pass_Str(OutMessage,String_status)
			
							ret = MessageBox(NULL, OutMessage, &
											 Boxtitle, messageBox_Icon)
							return
						endif
					else
						! if Query data is not valid then
						ret=LoadString(NULL, IDS_ERR_INVALID_QUERY_DATA, OutMessage, len(OutMessage))
						ret=MessageBox(NULL, OutMessage, &
							  	Boxtitle, messageBox_Icon)
						return
				endif
				else
					! if Query data is not valid then
					ret=LoadString(NULL, IDS_ERR_INVALID_QUERY_DATA, OutMessage, len(OutMessage))
					ret=MessageBox(NULL, OutMessage, &
							  	Boxtitle, messageBox_Icon)
					return
				endif
			else
				! if Query data is blank
				ret=LoadString(NULL, IDS_ERR_NO_QUERY_DATA, OutMessage, len(OutMessage))
				ret=MessageBox(NULL, OutMessage, &
							  Boxtitle, messageBox_Icon)
				return
			endif
		else
			! if cell address is not selected then 
			ret=LoadString(NULL, IDS_ERR_NO_ADDR, OutMessage, len(OutMessage))
			ret=MessageBox(NULL, OutMessage, &
							Boxtitle, messageBox_Icon)
			return
		endif
  endif

! if cell address is not valid hex string
100 	ret=LoadString(NULL, IDS_INVALID_ADDR, OutMessage, len(OutMessage))
	    ret=MessageBox(NULL, OutMessage, &
					 Boxtitle, messageBox_Icon)
		  return

  END SUBROUTINE Query_ONOK

!****************************************************************************
!
! End of  FUNCTION: Query_ONOK
!
!****************************************************************************

!****************************************************************************
!
!  FUNCTION: decrementCellAddress ( dlg, id, callbacktype )
!
!  PURPOSE:  This function executes during initialization of Decrement dialog 
!
!  COMMENTS:Sets CellAddress List box value.
!
!****************************************************************************

SUBROUTINE DecrementCellAddress( dlg, id, callbacktype )

use dflogm ! include file for Fortarn
  use dfwin ! include header file for fortran
  use SPROEVALGlobals ! file for global variables
  use spromeps_module ! file for API wrappers
  ! use spromeps_constants ! file for Constant and structure defination
  implicit none
  include 'resource.fd'
  character*2 :: cellAdd
  integer(kind=1) :: a
  type (dialog) dlg
  integer id, callbacktype
! for cell address
 	lret = DlgSet (dlg, DEC_ID, 64, DLG_NUMITEMS )
	DO a = 0, 63
		write (cellAdd,'(Z2.2)')  a
		
		lret = DlgSet (dlg, DEC_ID,cellAdd , a+1)
	end do		

	 	
END SUBROUTINE DecrementCellAddress


!****************************************************************************
!
! End of  FUNCTION: DecrementCellAddress
!
!****************************************************************************



!****************************************************************************
!
!  FUNCTION: Decrement_ONOK ( dlg, id, callbacktype )
!
!  PURPOSE:  This function executes on OK buttons clicks of decrement dialog 
!
!  COMMENTS:RNBOsprodecrement API calls here.
!
!****************************************************************************

SUBROUTINE Decrement_ONOK( dlg, id, callbacktype )

use dflogm ! include file for Fortarn
  use dfwin ! include header file for fortran
  use SPROEVALGlobals ! file for global variables
  use spromeps_module ! file for API wrappers
  ! use spromeps_constants ! file for Constant and structure defination
  include 'resource.fd'
  integer(kind=2) :: cellAddress				! cell Address
  Character*4 :: String_cellAddress  
  integer messageBox_Icon
  type (dialog) dlg
  integer id, callbacktype
    if (callbacktype == dlg_clicked) then
		ret=LoadString( NULL,IDS_DECREMENT,Boxtitle,len(Boxtitle)) 
		messageBox_Icon =MB_TASKMODAL		
		! get cell address value
		lret=DLGGET(dlg,DEC_ID,String_cellAddress)
		if (lret) then
			read (String_cellAddress, '(Z2)', ERR = 100 ) cellAddress ! hex to integer
			 
			! get write password value
			lret=DLGGET(dlg,DEC_WP,String_writePassword)
			! validate write password value
			dataLen=LEN_TRIM(String_writePassword)
			if (dataLen >0) then
				if (dataLen <= VALID_DATA_LENGTH) then ! validation for write password
					read (String_writePassword, '(Z4)' ,ERR=110) writePassword  	
					
					! RNBOsproDecrement API call
					status = RNBOsproDecrement(RNBOpacket%packet,writePassword,cellAddress) 
					
					! ***Comment: check whether API get success or not ****											
					if(status==0) then
						ret = LoadString( NULL,IDS_DEC_SUCCESS,OutMessage,len(OutMessage)) 
						ret = MessageBox(NULL, OutMessage, &
														 Boxtitle, messageBox_Icon)
						return
					else
						ret = LoadString( NULL,IDS_ERR_DEC_FAILED,OutMessage,len(OutMessage)) 
					
						write (String_status,'(I3,A)')  status ,'.'
						call Pass_Str(OutMessage,String_status)
			
						ret = MessageBox(NULL, OutMessage, &
											 Boxtitle, messageBox_Icon)
						return
						
					endif
				else
					! if invalid write password then 
					ret=LoadString(NULL, IDS_ERR_INVALID_WRITE_PASSWORD, OutMessage, len(OutMessage))
					ret=MessageBox(NULL, OutMessage, &
							  					 Boxtitle, messageBox_Icon)
					return
				endif
			else
				! if write password blank then 
				ret=LoadString(NULL, IDS_ERR_NO_WRITE_PASSWORD,OutMessage, len(OutMessage))
				ret=MessageBox(NULL, OutMessage, &
						 Boxtitle, messageBox_Icon)
				return
			endif
		else
			! if cell address blank
			ret=LoadString(NULL, IDS_ERR_NO_ADDR, OutMessage, len(OutMessage))
	    ret=MessageBox(NULL, OutMessage, &
					 Boxtitle, messageBox_Icon)
			return
		endif
  endif

! if cell address invalid then
100 	ret=LoadString(NULL, IDS_INVALID_ADDR, OutMessage, len(OutMessage))
	    ret=MessageBox(NULL, OutMessage, &
					 Boxtitle, messageBox_Icon)
			return
! if write password invalid then
110 	ret=LoadString(NULL, IDS_ERR_INVALID_WRITE_PASSWORD, OutMessage, len(OutMessage))
	    ret=MessageBox(NULL, OutMessage, &
					 Boxtitle, messageBox_Icon)
		return

  END SUBROUTINE Decrement_ONOK

!****************************************************************************
!
! End of  FUNCTION: decrement_ONOK
!
!****************************************************************************
!****************************************************************************
!
!  FUNCTION: ActivateCell ( dlg, id, callbacktype )
!
!  PURPOSE:  This function executes during initialization of Activate dialog 
!
!  COMMENTS:Sets CellAddress List box value.
!
!****************************************************************************

SUBROUTINE ActivateCell( dlg, id, callbacktype )

use dflogm ! include file for Fortarn
  use dfwin ! include header file for fortran
  use SPROEVALGlobals ! file for global variables
  use spromeps_module ! file for API wrappers
  ! use spromeps_constants ! file for Constant and structure defination
  implicit none
  include 'resource.fd'
  character*2 :: cellAdd
  integer(kind=1) :: a

  type (dialog) dlg
  integer id, callbacktype
! for cell address
	lret = DlgSet (dlg, ACT_ID, 64, DLG_NUMITEMS )
	DO a = 0, 63
		write (cellAdd,'(Z2.2)')  a
			
		lret = DlgSet (dlg, ACT_ID,cellAdd , a+1)
	end do		
   
END SUBROUTINE ActivateCell

!****************************************************************************
!
! End of  FUNCTION: ActivateCell
!
!****************************************************************************

!****************************************************************************
!
!  FUNCTION: Activate_ONOK ( dlg, id, callbacktype )
!
!  PURPOSE:  This function executes on OK buttons clicks of Activate dialog 
!
!  COMMENTS:RNBOsproActivatet API calls here.
!
!****************************************************************************

SUBROUTINE Activate_ONOK( dlg, id, callbacktype )

use dflogm ! include file for Fortarn
  use dfwin ! include header file for fortran
  use SPROEVALGlobals ! file for global variables
  use spromeps_module ! file for API wrappers
  ! use spromeps_constants ! file for Constant and structure defination

  include 'resource.fd'
  integer(kind=2) :: cellAddress				! cell Address
  Character*4 :: String_cellAddress
  integer(kind=4) ::ActivatePassword1 
  Character*32 :: String_ActivatePassword1
  integer(kind=4) ::ActivatePassword2 
  Character*32 :: String_ActivatePassword2
  type (dialog) dlg
  integer id, callbacktype
  integer messageBox_Icon
	
  if (callbacktype == dlg_clicked) then
		ret=LoadString( NULL,IDS_ACTIVATE_ALGO,Boxtitle,len(Boxtitle)) 
		messageBox_Icon =  MB_TASKMODAL		
		! get cell address value
		lret=DLGGET(dlg,ACT_ID,String_cellAddress)
		if (lret) then
			read (String_cellAddress, '(Z2)',err=100) cellAddress  ! convert into integer
			! get write password value
			lret=DLGGET(dlg,ACT_WP,String_writePassword)
			dataLen=LEN_TRIM(String_writePassword)
			
			if (dataLen >0) then ! validation for write password
				if (dataLen <= VALID_DATA_LENGTH) then
					read (String_writePassword, '(Z4)',ERR=110) writePassword  
					! get activate password value
					lret=DLGGET(dlg,ACT_AP1,String_ActivatePassword1)
					dataLen=LEN_TRIM(String_ActivatePassword1)
					if (dataLen >0) then
						if (dataLen <= VALID_DATA_LENGTH) then ! validation for Activate password1
							read (String_ActivatePassword1, '(Z4)',ERR=120) ActivatePassword1  			
							!  get activate password 2 value
							lret=DLGGET(dlg,ACT_AP2,String_ActivatePassword2)
							dataLen=LEN_TRIM(String_ActivatePassword2)
							if (dataLen >0) then
								if (dataLen <= VALID_DATA_LENGTH) then ! validation for Activate password2
									read (String_ActivatePassword2, '(Z4)',ERR=130) ActivatePassword2  
									
									
									! RNBOsproActivate API call
									status = RNBOsproActivate(RNBOpacket%packet,writePassword,ActivatePassword1,&
																						ActivatePassword2,cellAddress) 
									
									! ***Comment: check whether API get success or not ****											
									if(status==0) then
										ret = LoadString(NULL,IDS_ACTIVATE_SUCCESS,OutMessage,len(OutMessage)) 
										ret = MessageBox(NULL, OutMessage, &
																		 Boxtitle, messageBox_Icon)
										return
									else
										ret = LoadString( NULL,IDS_ERR_ACTIVATE_FAILED,OutMessage,len(OutMessage)) 
									
										write (String_status,'(I3,A)')  status ,'.'
										call Pass_Str(OutMessage,String_status)
			
										ret = MessageBox(NULL, OutMessage, &
														 Boxtitle, messageBox_Icon)
										return
										
									endif

								else ! if acitvate password 2 is invalid
									ret=LoadString(NULL, IDS_ERR_INVALID_ACTIVATE2_PASSWORD, OutMessage,&
																 len(OutMessage))
											ret=MessageBox(NULL, OutMessage, &
							  											Boxtitle, messageBox_Icon)
									return
								endif
							else ! if activate password 2 is blank
								ret=LoadString(NULL, IDS_ERR_NO_ACTIVATE2_PASSWORD, OutMessage, len(OutMessage))
								ret=MessageBox(NULL, OutMessage, &
							  					 Boxtitle, messageBox_Icon)
								return
							endif
						else ! if acitvate password 2 is invalid
							ret=LoadString(NULL, IDS_ERR_INVALID_ACTIVATE1_PASSWORD, OutMessage, len(OutMessage))
							ret=MessageBox(NULL, OutMessage, &
							  					 Boxtitle, messageBox_Icon)
							return
						endif
					else ! if activate password 2 is blank
						ret=LoadString(NULL, IDS_ERR_NO_ACTIVATE1_PASSWORD, OutMessage, len(OutMessage))
						ret=MessageBox(NULL, OutMessage, &
							  					 Boxtitle, messageBox_Icon)
						return
					endif
				else ! if write password 2 is invalid
					ret=LoadString(NULL, IDS_ERR_INVALID_WRITE_PASSWORD, OutMessage, len(OutMessage))
					ret=MessageBox(NULL, OutMessage, &
							  					 Boxtitle, messageBox_Icon)
					return
				endif
			else ! if write password 2 is blank
				ret=LoadString(NULL, IDS_ERR_NO_WRITE_PASSWORD, OutMessage, len(OutMessage))
				ret=MessageBox(NULL, OutMessage, &
							  					 Boxtitle, messageBox_Icon)
				return
			endif
		else ! if cell address is not selected
			ret=LoadString(NULL, IDS_ERR_NO_ADDR, OutMessage, len(OutMessage))
	    ret=MessageBox(NULL, OutMessage, &
					 Boxtitle, messageBox_Icon)
			return
	  endif
	endif
! if celladdress is invalid hex string  
100 	ret=LoadString(NULL, IDS_INVALID_ADDR, OutMessage, len(OutMessage))
	    ret=MessageBox(NULL, OutMessage, &
					 Boxtitle, messageBox_Icon)
		  return
! if write password is invalid hex string
110 	ret=LoadString(NULL, IDS_ERR_INVALID_WRITE_PASSWORD, OutMessage, len(OutMessage))
	    ret=MessageBox(NULL, OutMessage, &
					 Boxtitle, messageBox_Icon)
		return
! if activate password1 is invalid hex string
120 	ret=LoadString(NULL, IDS_ERR_INVALID_ACTIVATE1_PASSWORD, OutMessage, len(OutMessage))
	    ret=MessageBox(NULL, OutMessage, &
					 Boxtitle, messageBox_Icon)
		  return
! if activate password2 is invalid hex string
130 	ret=LoadString(NULL, IDS_ERR_INVALID_ACTIVATE2_PASSWORD, OutMessage, len(OutMessage))
	    ret=MessageBox(NULL, OutMessage, &
					 Boxtitle, messageBox_Icon)
		return


	END SUBROUTINE Activate_ONOK

!****************************************************************************
!
! End of  FUNCTION: Activate
!
!****************************************************************************
!****************************************************************************
!
!  FUNCTION: GetSubLicense ( dlg, id, callbacktype )
!
!  PURPOSE:  This function executes during initialization of GetSubLicense dialog 
!
!  COMMENTS:Sets CellAddress and accessCode List box value.
!
!****************************************************************************

SUBROUTINE GetSubLicenseCellAddress( dlg, id, callbacktype )


use dflogm ! include file for Fortarn
  use dfwin ! include header file for fortran
  use SPROEVALGlobals ! file for global variables
  use spromeps_module ! file for API wrappers
  ! use spromeps_constants ! file for Constant and structure defination
  implicit none
  include 'resource.fd'
  character*2 :: cellAdd
  integer(kind=1) :: a
  type (dialog) dlg
  integer id, callbacktype
! for cell address
 	lret = DlgSet (dlg, CELL_ADD, 64, DLG_NUMITEMS )
	DO a = 0, 63
		write (cellAdd,'(Z2.2)')  a
		
		lret = DlgSet (dlg, CELL_ADD,cellAdd , a+1)
	end do		

	
END SUBROUTINE GetSubLicenseCellAddress

!****************************************************************************
!
! End of  FUNCTION: GetSubLicenseCellAddress
!
!****************************************************************************


!****************************************************************************
!
!  FUNCTION: GetSubLicense_ONOK ( dlg, id, callbacktype )
!
!  PURPOSE:  This function executes on OK buttons clicks of GetSublicense dialog 
!
!  COMMENTS:RNBOsproGetSubLicense API calls here.
!
!****************************************************************************

SUBROUTINE GetSubLicense_ONOK( dlg, id, callbacktype )

use dflogm ! include file for Fortarn
  use dfwin ! include header file for fortran
  use SPROEVALGlobals ! file for global variables
  use spromeps_module ! file for API wrappers
  ! use spromeps_constants ! file for Constant and structure defination
  include 'resource.fd'
  integer(kind=2) :: cellAddress				! cell Address
  Character*4 :: String_cellAddress
  type (dialog) dlg
  integer id, callbacktype
  integer messageBox_Icon

  if (callbacktype == dlg_clicked) then
		ret=LoadString( NULL,IDS_GET_SUB_LIC,Boxtitle,len(Boxtitle)) 
		messageBox_Icon =MB_TASKMODAL		
		! get cell address value
		lret=DLGGET(dlg,CELL_ADD,String_cellAddress)
		if (lret) then
			read (String_cellAddress, '(Z2)',ERR=100) cellAddress  !hex to integer
			
			
			! RNBOsproGetSubLicense API call
			
			status = RNBOsproGetSubLicense(RNBOpacket%packet,cellAddress) 
			
			! ***Comment: check whether API get success or not ****											
			if(status==0) then
				ret = LoadString(NULL,IDS_GET_SUB_LIC_SUCCESS,OutMessage,len(OutMessage)) 
				ret = MessageBox(NULL, OutMessage, &
												 Boxtitle, messageBox_Icon)
				return
			else
				ret = LoadString( NULL,IDS_ERR_GET_SUB_LIC_FAILED,OutMessage,len(OutMessage)) 
			
				write (String_status,'(I3,A)')  status ,'.'
				call Pass_Str(OutMessage,String_status)
			
				ret = MessageBox(NULL, OutMessage, &
								 Boxtitle, messageBox_Icon)
				return
			endif
		else
			!if cell address is not selected
			ret=LoadString(NULL, IDS_ERR_NO_ADDR, OutMessage, len(OutMessage))
			ret=MessageBox(NULL, OutMessage, &
						 Boxtitle,messageBox_Icon)
			return
		endif	
	
	endif
! if cell address is invalid
100 	ret=LoadString(NULL, IDS_INVALID_ADDR, OutMessage, len(OutMessage))
	    ret=MessageBox(NULL, OutMessage, &
					 Boxtitle, messageBox_Icon)
		  return

END SUBROUTINE GetSubLicense_ONOK


!****************************************************************************
!
! End of  FUNCTION: GetSubLicense_ONOK
!
!****************************************************************************
!****************************************************************************
!
!  FUNCTION: ReleaseLicenseCellAddress ( dlg, id, callbacktype )
!
!  PURPOSE:  This function executes during initialization of ReleaseLicense dialog 
!
!  COMMENTS:Sets CellAddress and accessCode List box value.
!
!****************************************************************************

SUBROUTINE ReleaseLicenseCellAddress( dlg, id, callbacktype )

use dflogm ! include file for Fortarn
  use dfwin ! include header file for fortran
  use SPROEVALGlobals ! file for global variables
  use spromeps_module ! file for API wrappers
  ! use spromeps_constants ! file for Constant and structure defination
  implicit none
  include 'resource.fd'
  character*2 :: cellAdd
  integer(kind=1) :: a

  type (dialog) dlg
  integer id, callbacktype
! for cell address
 	lret = DlgSet (dlg, CELL_ADD, 64, DLG_NUMITEMS )
	DO a = 0, 63
		write (cellAdd,'(Z2.2)')  a
			
		lret = DlgSet (dlg, CELL_ADD,cellAdd , a+1)
	end do		
 
  					
	
END SUBROUTINE ReleaseLicenseCellAddress


!****************************************************************************
!
! End of  FUNCTION: ReleaseLicenseCellAddress
!
!****************************************************************************


!****************************************************************************
!
!  FUNCTION: ReleaseLicense_ONOK ( dlg, id, callbacktype )
!
!  PURPOSE:  This function executes on OK buttons clicks of ReleaseLicense dialog 
!
!  COMMENTS:RNBOsproreleaseLicense API calls here.
!
!****************************************************************************

SUBROUTINE ReleaseLicense_ONOK( dlg, id, callbacktype )

use dflogm ! include file for Fortarn
  use dfwin ! include header file for fortran
  use SPROEVALGlobals ! file for global variables
  use spromeps_module ! file for API wrappers
  ! use spromeps_constants ! file for Constant and structure defination
  include 'resource.fd'
  integer(kind=2) :: cellAddress				! cell Address
  Character*4 :: String_cellAddress
  integer(kind=4) :: NumLic				! cell Address
  Character*32 :: String_NumLic
  type (dialog) dlg
  integer id, callbacktype
	integer messageBox_Icon
		  
	if (callbacktype == dlg_clicked) then
		
		ret=LoadString( NULL,IDS_REL_LIC,Boxtitle,len(Boxtitle)) 
		messageBox_Icon =  MB_TASKMODAL		
		lret=DLGGET(dlg,CELL_ADD,String_cellAddress)
		if (lret) then	
			read (String_cellAddress, '(Z2)',ERR=100) cellAddress  !hex to integer
			
			lret=DLGGET(dlg,NO_OF_LIC,String_NumLic)
			dataLen=LEN_TRIM(String_NumLic)
			if (dataLen >0) then ! validation for numLic value
  			read (String_NumLic, '(I8)',ERR=110) NumLic !convert string to int
				if (NumLic >=0 .AND. NumLic <=65535) then ! ceck for valid numLic value
					
					! RNBOsproReleaseLicense API call
					status = RNBOsproReleaseLicense(RNBOpacket%packet,cellAddress,NumLic) 

					! ***Comment: check whether API get success or not ****											
					if(status==0) then
						ret = LoadString(NULL,IDS_REL_LIC_SUCCESS,OutMessage,len(OutMessage)) 
							ret = MessageBox(NULL, OutMessage, &
												 Boxtitle, messageBox_Icon)
						call DLGEXIT(dlg)
						return
					else
						ret = LoadString( NULL,IDS_ERR_RELEASE_FAILED,OutMessage,len(OutMessage)) 
						write (String_status,'(I3,A)')  status ,'.'
						call Pass_Str(OutMessage,String_status)
			
						ret = MessageBox(NULL, OutMessage, &
											 Boxtitle, messageBox_Icon)
						return
					endif
				else
				! if num license value is invalid
					ret=LoadString(NULL, IDS_ERR_INVALID_NUM_LIC_VALUE, OutMessage, len(OutMessage))
					ret=MessageBox(NULL, OutMessage, &
												 Boxtitle,  messageBox_Icon)
					return
				endif
			else
				! if numLicense value blank
				ret=LoadString(NULL, IDS_ERR_NO_NUM_LIC_VALUE, OutMessage, len(OutMessage))
				ret=MessageBox(NULL, OutMessage, &
											 Boxtitle, messageBox_Icon)
				return
			endif
		else
			! cell address is not selected
			ret=LoadString(NULL, IDS_ERR_NO_ADDR, OutMessage, len(OutMessage))
	    ret=MessageBox(NULL, OutMessage, &
										 Boxtitle,  messageBox_Icon)
			return
	  endif
	endif  
100 	ret=LoadString(NULL, IDS_INVALID_ADDR, OutMessage, len(OutMessage))
	    ret=MessageBox(NULL, OutMessage, &
					 Boxtitle,messageBox_Icon)
		  return
110 	ret=LoadString(NULL, IDS_ERR_INVALID_NUM_LIC_VALUE, OutMessage, len(OutMessage))
	    ret=MessageBox(NULL, OutMessage, &
					 Boxtitle, messageBox_Icon)
		  return

  END SUBROUTINE ReleaseLicense_ONOK

!****************************************************************************
!
! End of  FUNCTION: releaseLicense_ONOK
!
!****************************************************************************


!****************************************************************************
!
!  FUNCTION: SetContactServer_ONOK ( dlg, id, callbacktype )
!
!  PURPOSE:  This function executes on OK buttons clicks of SetContactServer dialog 
!
!  COMMENTS:RNBOsproSetContactServer API calls here.
!
!****************************************************************************
SUBROUTINE SetContactServer_ONOK( dlg, id, callbacktype )

use dflogm ! include file for Fortarn
  use dfwin ! include header file for fortran
  use SPROEVALGlobals ! file for global variables
  use spromeps_module ! file for API wrappers
  ! use spromeps_constants ! file for Constant and structure defination
   character(len=63) :: serverName
	 character(len=70) :: temp_serverName
  include 'resource.fd'
  type (dialog) dlg
  integer id, callbacktype
  integer messageBox_Icon

  if (callbacktype == dlg_clicked) then
		ret=LoadString( NULL,IDS_SET_CON_SRVR,Boxtitle,len(Boxtitle)) 
		messageBox_Icon =MB_TASKMODAL		
		
			lret=DLGGET(dlg,ID_SRV_NAME,temp_serverName)
		dataLen=LEN_TRIM(temp_serverName)
		
		if (dataLen <=63) then	
			
			lret=DLGGET(dlg,ID_SRV_NAME,serverName)
			! RNBOsproSetContactServer API call
			status = RNBOsproSetContactServer(RNBOpacket%packet, serverName)
			
			! ***Comment: check whether API get success or not ****											
			if(status==0) then
				ret = LoadString(NULL,IDS_SET_CON_SRVR_SUCCESS,OutMessage,len(OutMessage)) 
				ret = MessageBox(NULL, OutMessage, &
												 Boxtitle, messageBox_Icon)
				call DLGEXIT(dlg)
				return
			else
				ret = LoadString( NULL,IDS_INVALID_OPERATION,OutMessage,len(OutMessage)) 
				write (String_status,'(I3,A)')  status ,'.'
				call Pass_Str(OutMessage,String_status)
		
				ret = MessageBox(NULL, OutMessage, &
										 Boxtitle, messageBox_Icon)
				return
			endif
		else
			! if contactServer string length is not valid
			ret=LoadString(NULL, IDS_INVALID_CON_SRVR, OutMessage, len(OutMessage))
			ret=MessageBox(NULL, OutMessage, &
									 Boxtitle, messageBox_Icon)
			return
		endif
		
	endif  

END SUBROUTINE SetContactServer_ONOK

!****************************************************************************
!
! End of  FUNCTION: SetContactServer_ONOK
!
!****************************************************************************



!****************************************************************************
!
!  FUNCTION: GetKeyInfo_ONOK ( dlg, id, callbacktype )
!
!  PURPOSE:  This function executes on NextKey button clicks of GetKeyInfo dialog 
!
!  COMMENTS:RNBOsproGetKeyInfo API calls here.
!
!****************************************************************************

SUBROUTINE GetKeyInfo_ONOK( dlg, id, callbacktype )

use dflogm ! include file for Fortarn
  use dfwin ! include header file for fortran
  use SPROEVALGlobals ! file for global variables
  use spromeps_module ! file for API wrappers
  ! use spromeps_constants ! file for Constant and structure defination
  include 'resource.fd'
  type (dialog) dlg
  integer id, callbacktype
  integer(kind=4) :: KeyID		
	
    				! cell Address
  ! string variable for key info
	Character*32 :: String_KeyID
	
	Character*4 :: String_devId
	Character*6 :: String_hardlimit
	Character*6 :: String_inUse	
	Character*6 :: String_numTimeout
	Character*6 :: String_highestUse
	type(NSPRO_MONITOR_INFO) :: monitorInfo
	integer messageBox_Icon

  if (callbacktype == dlg_clicked) then
		ret=LoadString( NULL,IDS_GET_KEY_INFO,Boxtitle,len(Boxtitle)) 
		messageBox_Icon =  MB_TASKMODAL		
		lret=DLGGET(dlg,IDC_DEVID,String_KeyID)
		KeyIndex =KeyIndex + 1
		dataLen=LEN_TRIM(String_KeyID)
		if (dataLen >0) then ! validation for KeyID value
			if (dataLen <=4) then	
				read (String_KeyID, '(Z4)',ERR=100) KeyID  		!convert string to integer
				
				
				! RNBOsproGetKeyInfo API call
				status = RNBOsproGetKeyInfo(RNBOpacket%packet, KeyID, KeyIndex, monitorInfo)
				
					! ***Comment: check whether API get success or not ****											
				if(status==0) then
					! convert GetKeyInfo structure value into string 
					write (String_devId, '(Z4)') monitorInfo%sproKeyMonitorInfo%devId
					! 
					if(monitorInfo%sproKeyMonitorInfo%hardLimit == -1) then
						write (String_hardlimit, '(A)') '65535'
					else
						write (String_hardlimit, '(I6)') monitorInfo%sproKeyMonitorInfo%hardLimit
					endif
					write (String_inUse, '(I6)') monitorInfo%sproKeyMonitorInfo%inUse
					write (String_numTimeout, '(I6)') monitorInfo%sproKeyMonitorInfo%numTimeOut
					write (String_highestUse, '(I6)') monitorInfo%sproKeyMonitorInfo%highestUse			
						
					!display KeyInfo value as putput
					lret=DLGSET(dlg,IDC_DEVID,String_devId)
					lret=DLGSET(dlg,IDC_HRD_LMT,String_hardlimit)
					lret=DLGSET(dlg,IDC_LIC_INUSE,String_inUse)
					lret=DLGSET(dlg,IDC_NUM_TIMED_OUT,String_numTimeout)
					lret=DLGSET(dlg,IDC_HIGHEST_IN_USE,String_highestUse)
					return
				else
					ret = LoadString( NULL,IDS_GET_KEY_INFO_FAILED,OutMessage,len(OutMessage)) 
					write (String_status,'(I3,A)')  status ,'.'
					call Pass_Str(OutMessage,String_status)
			
					ret = MessageBox(NULL, OutMessage, &
											 Boxtitle, messageBox_Icon)
					return
				endif
			else
			!if KeyID is invalid
				ret=LoadString(NULL, IDS_INVALID_DEVID, OutMessage, len(OutMessage))
				ret=MessageBox(NULL, OutMessage, &
										 Boxtitle, messageBox_Icon)
				return
			endif
		else
		! if KeyId is blank
			ret=LoadString(NULL, IDS_ERR_NO_DEV_ID, OutMessage, len(OutMessage))
			ret=MessageBox(NULL, OutMessage, &
										 Boxtitle, messageBox_Icon)
			return
		endif
	endif  

100 	ret=LoadString(NULL, IDS_INVALID_DEVID, OutMessage, len(OutMessage))
	    ret=MessageBox(NULL, OutMessage, &
					 Boxtitle,  messageBox_Icon)
		  return

END SUBROUTINE GetKeyInfo_ONOK

!****************************************************************************
!
! End of  FUNCTION: GetKeyInfo_ONOK
!
!****************************************************************************


!****************************************************************************
!
!  FUNCTION: EnumServer_ONOK ( dlg, id, callbacktype )
!
!  PURPOSE:  This function executes on NextKey button clicks of EnumServer dialog 
!
!  COMMENTS:RNBOsproenumServer API calls here.
!
!****************************************************************************

SUBROUTINE EnumServer_ONOK( dlg, id, callbacktype )

use dflogm ! include file for Fortarn
  use dfwin ! include header file for fortran
  use SPROEVALGlobals ! file for global variables
  use spromeps_module ! file for API wrappers
  ! use spromeps_constants ! file for Constant and structure defination
  include 'resource.fd'
  type (dialog) dlg
  integer id, callbacktype
  integer(kind=4) :: KeyID				
  integer(kind=2) :: NumServers		
  integer(kind=2) :: EnumFlag
  type(NSPRO_SERVER_INFO), dimension(0:9) :: serverInfo				! array of Server info structure
  Character*32 :: String_KeyID
  Character*32 :: String_NumServers
  integer(kind=4) :: String_EnumFlag
  integer(kind=2) :: j
  Character(len=120) :: String_Server
  integer messageBox_Icon
  
	if (callbacktype == dlg_clicked) then
		ret=LoadString( NULL,IDS_ENUM_SERVER,Boxtitle,len(Boxtitle)) 
		messageBox_Icon =  MB_TASKMODAL		
		lret=DLGGET(dlg,IDC_DEVID,String_KeyID)
		dataLen=LEN_TRIM(String_KeyID)
		if (dataLen >0) then ! validation for KeyID valye
			if (dataLen <=4) then	
				read (String_KeyID, '(Z5)',ERR=100) KeyID 
				lret=DLGGETINT(dlg,COMBO_ENSRVR_FLG,String_EnumFlag,DLG_STATE)
				if(lret) then ! For EnumFlag value
					SELECT CASE (String_EnumFlag)
					CASE (1)
						EnumFlag = NSPRO_GET_ALL_SERVERS
					CASE (2)
						EnumFlag = NSPRO_RET_ON_FIRST
						
					CASE (3)
						EnumFlag = NSPRO_RET_ON_FIRST_AVAILABLE
	
					END SELECT 
					lret=DLGGET(dlg,IDC_NUMSRVRS,String_NumServers)
					dataLen=LEN_TRIM(String_NumServers)
					if (dataLen >0) then ! validation for NumofServers value
  					read (String_NumServers, '(I2)',ERR=110) NumServers  
						if (NumServers >=0 .AND. NumServers <=10) then
							
							
							! RNBOsproEnumServer API call
							status = RNBOsproEnumServer(EnumFlag, KeyID, serverInfo, NumServers)
							! ***Comment: check whether API get success or not ****											
							if(status==0) then
								ret = LoadString( NULL,IDS_ENUM_SUCC,OutMessage,len(OutMessage)) 
								ret = MessageBox(NULL,OutMessage, &
																	Boxtitle,messageBox_Icon)	
								write (String_NumServers, '(I2)') NumServers  
								lret=DLGSET(dlg,IDC_NUMSRVRS,String_NumServers)
								lret=DlgSet (dlg, COMBO_SRVR_INFO, 0, DLG_NUMITEMS )
								!display server info value for outupt
								DO j = 0, NumServers - 1
									if(serverInfo(j)%numLicAvail == -1) then
										write (String_Server, '(A,A,A)') 'License = 65535',', Server = ', serverInfo(j)%serverAddress 
									else
										write (String_Server, '(A,I,A,A)') 'License =',serverInfo(j)%numLicAvail,', Server = ', serverInfo(j)%serverAddress 
									endif
									lret=DLGSET(dlg,COMBO_SRVR_INFO,String_Server,DLG_ADDSTRING)
								END DO
								return
							else
								ret = LoadString( NULL,IDS_ENSRVR_FAILED,OutMessage,len(OutMessage)) 
								write (String_status,'(I3,A)')  status ,'.'
								call Pass_Str(OutMessage,String_status)
			
								ret = MessageBox(NULL, OutMessage, &
												 Boxtitle, messageBox_Icon)
								return
							endif
						else
							ret=LoadString(NULL, IDS_ERR_INVALID_NUMSERVER_VALUE, OutMessage, len(OutMessage))
							ret=MessageBox(NULL, OutMessage, &
														 Boxtitle, messageBox_Icon)
							return
						endif
					else
						ret=LoadString(NULL, IDS_ERR_NO_NUMSERVER_VALUE, OutMessage, len(OutMessage))
						ret=MessageBox(NULL, OutMessage, &
													 Boxtitle,messageBox_Icon)
						return
					endif
				else
					ret = MessageBox(NULL, "Select protocolFlag value."C, &
													 Boxtitle, messageBox_Icon)
					return
				endif
			else
				ret=LoadString(NULL, IDS_INVALID_DEVID, OutMessage, len(OutMessage))
				ret=MessageBox(NULL, OutMessage, &
										 Boxtitle, messageBox_Icon)
				return
			endif
		else
			ret=LoadString(NULL, IDS_ERR_NO_DEV_ID, OutMessage, len(OutMessage))
			ret=MessageBox(NULL, OutMessage, &
										 Boxtitle, messageBox_Icon)
			return
		endif
	endif	

100 	ret=LoadString(NULL, IDS_INVALID_DEVID, OutMessage, len(OutMessage))
	    ret=MessageBox(NULL, OutMessage, &
					 Boxtitle,  messageBox_Icon)
		  return

110 	ret=LoadString(NULL, IDS_ERR_INVALID_NUMSERVER_VALUE, OutMessage, len(OutMessage))
	    ret=MessageBox(NULL, OutMessage, &
					 Boxtitle, messageBox_Icon)
		  return
END SUBROUTINE EnumServer_ONOK

!****************************************************************************
!
! End of  FUNCTION: EnumServer_ONOK
!
!****************************************************************************

!****************************************************************************
!
!  FUNCTION: KeyView_Update ( dlg, id, callbacktype )
!
!  PURPOSE:  This function executes on Update button clicks of KeyView dialog 
!
!  COMMENTS:RNBOsproenumServer API calls here.
!
!****************************************************************************


SUBROUTINE KeyView_Update( dlg, id, callbacktype )
use dflogm ! include file for Fortarn
  use dfwin ! include header file for fortran
  use SPROEVALGlobals ! file for global variables
  use spromeps_module ! file for API wrappers
  ! use spromeps_constants ! file for Constant and structure defination
  include 'resource.fd'
  type (dialog) dlg
  integer id, callbacktype
  	 
	 ! some temp string variable to make Key veiw in proper format
	 character(len=100) :: viewMessage
 character(len=5)  :: String1
 character(len=6)  :: String2
 character(len=6)  :: String3
 character(len=5)  :: String4
 character(len=6)  :: String5
 character(len=6)  :: String6
 character(len=5)  :: String7
 character(len=6)  :: String8
 character(len=6)  :: String9
 character(len=5)  :: String10
 character(len=6)  :: String11
 character(len=6)  :: String12
 
  integer(kind=2) ::  a
   integer(kind=2) ::   b
   integer(kind=4) :: OutData				! outdata
  Character*4 :: String_OutData !string variable for out data
  integer(kind=1) :: accessCode = 0 ! access code
  Character*4 :: String_AccessCode 

	viewMessage ='' ! assign blank value for string
	
		
		
	if (callbacktype == dlg_clicked .OR. callbacktype == dlg_INIT) then

		lret=DlgSet (dlg, IDC_VIEW, 0, DLG_NUMITEMS )
		
		! for static heading of KeyView
		write (viewMessage, '(A)') ' Adr  Data  AC    Adr  Data  AC    Adr  Data  AC    Adr  Data  AC'
		lret =  DLGSETchar(dlg,IDC_VIEW,viewMessage,DLG_ADDSTRING)
		
		! for static heading of KeyView
		write (viewMessage, '(A)') ' ---  ----  --    ---  ----  --    ---  ----  --    ---  ----  -- '
		lret =  DLGSETchar(dlg,IDC_VIEW,viewMessage,DLG_ADDSTRING)
		! loop for 16 rows of key view
		DO a = 0, 15
			
						
			! for 1st coloumn of Key view
			OutData= 0
			accessCode = 0
			write (String1, '(Z2.2)') (a+16*0)
			status = RNBOsproExtendedRead(RNBOpacket%packet,(a+16*0),Outdata,accessCode) 
			if(status <> 0) then
				String2='????  '	
				if ( status == SP_ACCESS_DENIED ) then
					String3=' ?    '	
				else
					String3=' 3    '	
				endif
			else
				write (String2, '(Z4.4)') OutData  
				write (String3, '(Z2)') accessCode	
			endif
			
			! for 2nd coloumn of Key view
			OutData= 0
			accessCode = 0
			write (String4, '(Z2.2)') (a+16*1)
			status = RNBOsproExtendedRead(RNBOpacket%packet,(a+16*1),Outdata,accessCode) 
			if(status <> 0) then
				String5='????  '	
				if ( status == 4) then
					String6=' ?    '	
				else
					String6=' 3    '	
				endif
			else
				write (String5, '(Z4.4)') OutData  
				write (String6, '(Z2)') accessCode	
			endif
			
			! for 3rd coloumn of Key view
			OutData= 0
			accessCode = 0
			write (String7, '(Z2.2)') (a+16*2)
			status = RNBOsproExtendedRead(RNBOpacket%packet,(a+16*2),Outdata,accessCode) 
			if(status <> 0) then
				String8='????  '	
				if ( status == 4 ) then
					String9=' ?    '	
				else
					String9=' 3    '	
				endif
			else
				write (String8, '(Z4.4)') OutData  
				write (String9, '(Z2)') accessCode	
			endif
			
			! for 4th coloumn of Key view
			OutData= 0
			accessCode = 0
			write (String10, '(Z2.2)') (a+16*3)
			status = RNBOsproExtendedRead(RNBOpacket%packet,(a+16*3),Outdata,accessCode) 
			if(status <> 0) then
				String11='????  '	
				if ( status == SP_ACCESS_DENIED ) then
					String12=' ?    '	
				else
					String12=' 3    '	
				endif
			else
				write (String11, '(Z4.4)') OutData  
				write (String12, '(Z2)') accessCode	
			endif
			
			! Set first rows of key view list box
			lret =DLGSETchar(dlg,IDC_VIEW,' ' // String1 // String2 // String3 // String4 // String5 // &
						String6 // String7 // String8 // String9 // String10 // String11 // String12,DLG_ADDSTRING)
		end do ! end of key view loop
	endif  

END SUBROUTINE KeyView_Update


!****************************************************************************
!
! End of  FUNCTION: KeyView_Update
!
!****************************************************************************
  

!****************************************************************************
!
!  FUNCTION: Exitmain ( dlg, id, callbacktype )
!
!  PURPOSE:  This function executes on Exit button 
!
!  COMMENTS:RNBOsproReleaseLicense API call here to release all license before closing application
!
!****************************************************************************

SUBROUTINE ExitMain( dlg, id, callbacktype )

use dflogm ! include file for Fortarn
  use dfwin ! include header file for fortran
  use SPROEVALGlobals ! file for global variables
  use spromeps_module ! file for API wrappers
  ! use spromeps_constants ! file for Constant and structure defination
  character(len=255) :: Msg
	integer(kind=4) :: NumLic				! cell Address
	integer(kind=2) :: cellAddress				! cell Address
  type (dialog) dlg
  integer id, callbacktype
  

 cellAddress=0
 NumLic=0
  if (callbacktype == dlg_clicked) then
		
		status = RNBOsproReleaseLicense(RNBOpacket%packet,cellAddress,NumLic)
		call PostQuitMessage(0)
  endif

END SUBROUTINE ExitMain
!****************************************************************************
!
! End of  FUNCTION: ExitMain
!
!****************************************************************************

 


!****************************************************************************
!
!  FUNCTION: Pass_Str (string1,string2)
!
!  PURPOSE:  to concatnate to string value for output
!
!  COMMENTS:
!
!****************************************************************************
SUBROUTINE Pass_Str (string1,string2)
  use dflogm
	use dfwin
  implicit none
  CHARACTER(*) string1 
	CHARACTER(*) string2 
  integer*4			    ret1
	!concat string values 		       
	ret1=lstrcat (string1, string2)	   
END SUBROUTINE

!****************************************************************************
!
! End of  FUNCTION: Pass_Str
!
!****************************************************************************

!****************************************************************************
!
!  FUNCTION:  ConvertBufferToHex(UserQuerydata,HexQuerydata,size,valid)
!
!  PURPOSE:  This function used to convert string query data to array of  integer value 
!
!****************************************************************************

SUBROUTINE ConvertBufferToHex(UserQuerydata,HexQuerydata,size,valid)
	use dflogm
	use dfwin
	use SPROEVALGlobals
	implicit none

	CHARACTER(*) UserQuerydata 
	integer(kind=2) size
	character(kind=1) , dimension(size/2) :: HexQuerydata
	integer(kind=1) :: valid 
	integer(kind=2) :: i
	integer(kind=2) :: j
	integer(kind=2) :: hidataByte
	integer(kind=2) :: lowByte
	integer(kind=2) :: dataLen1
	character(kind=1) :: Query_char1
	character (kind=1) :: Query_char2
	integer(kind=1) :: isvalid
	dataLen1=LEN_TRIM(UserQuerydata)   

	j=1
	do i=1,dataLen1,2 ! loop to convert string into array of half lentgh of integer value

		isvalid=0
		Query_char1=UserQuerydata(i:i) ! assign ith character of string to character type variable
		Query_char2=UserQuerydata(i+1:i+1)! assign ith+1 character of string to character type variable
		call ToUpper(Query_char1, isvalid) ! convert ith char to uper case and check for valid hex char

		if (isvalid == 0) then
		valid =0
		return
		end if
		! convert i+1th  char to uper case and check for valid hex char
		call ToUpper(Query_char2, isvalid)
		if (isvalid == 0) then
		valid =0
		return
		end if

		! if character is valid int character digit 	
		if (Query_char1 == '0' .OR. Query_char1 == '1' .OR. Query_char1 == '2' .OR. &
		Query_char1 == '3' .OR.	 Query_char1 == '4' .OR. Query_char1 == '5' .OR. &
		Query_char1 == '6' .OR. Query_char1 == '7' .OR.	 Query_char1 == '8' .OR. &
		Query_char1 == '9' ) then

			hidataByte = (Ichar(Query_char1) - 48) * 16 ! asschi value 
			else
			hidataByte = (Ichar(Query_char1) - 55) * 16 ! aschi value
		
		end if 

		! if character is valid int character digit 	
		if (Query_char2 == '0' .OR. Query_char2 == '1' .OR. Query_char2 == '2' .OR. &
		Query_char2 == '3' .OR.	 Query_char2 =='4' .OR. Query_char2 == '5' .OR. &
		Query_char2 == '6' .OR. Query_char2 == '7' .OR.	 Query_char2 == '8' .OR.&
		Query_char2 =='9' ) then

			lowByte = (ICHAR(Query_char2) - 48) 
			else
			lowByte = (ICHAR(Query_char2) - 55) 
		end if

		! assign sum of asschi value  i and i+1 th character to jth element of integer array
		HexQuerydata(j:j)=char(hidataByte + lowByte) ! 
		j=j+1

	end do
	valid =1 ! valid input query data
	return
END SUBROUTINE ConvertBufferToHex

!****************************************************************************
!
! End of  FUNCTION: ConvertBufferToHex
!
!****************************************************************************

!****************************************************************************
!
!  FUNCTION:  ConvertHexTochar(queryResponse,outputQueryData,size)
!
!  PURPOSE:  This function used to convert response of  queryAPI
!						to hex string for display
!
!****************************************************************************

	SUBROUTINE ConvertHexTochar(queryResponse,outputQueryData,size)
	use dflogm
	use dfwin
	use SPROEVALGlobals
	implicit none
	integer(kind=2) :: size
	integer(kind=1) ,dimension(size/2) :: queryResponse 
	CHARACTER(kind=1),dimension(size) :: outputQueryData 
	CHARACTER(kind=1),dimension(2) :: String_outputQueryData 
	integer(kind=2) :: i
	integer(kind=2) :: j
    j=1
    do i = 1 ,size/2
			!call subroutine to convert int hex character
			call intTohex(queryResponse(i),String_outputQueryData,2)
			! reverse of characret string
			outputQueryData(j)=String_outputQueryData(2)   
			outputQueryData(j+1)=String_outputQueryData(1)   
			j=j+2
	end do
    	
	return

END SUBROUTINE ConvertHexTochar
!****************************************************************************
!
! End of  FUNCTION: ConvertHexTochar
!
!****************************************************************************


!****************************************************************************
!
!  FUNCTION:  intTohex(decValue ,outdata,  length) 
!
!  PURPOSE:  This function used to convert integer ascii value to character 
!
!****************************************************************************

Subroutine intTohex(decValue ,outdata,  length) 

	integer(kind=1) :: decValue
	CHARACTER (kind=1) ,dimension(2):: OUTDATA
	integer(kind=2) :: length
	integer(kind=2) :: quotient 
  Integer(kind=1) :: remainder
  integer(kind=1) :: count 
	integer(kind=1) :: i
	integer(kind=1) :: index
	character(kind=1) :: hexChar
	
	i=1
	count=0
  quotient =decValue
	if (quotient .LT. 0) then ! if value is negative then 
		quotient =256 + quotient
	end if
	do while ((quotient .GT. 0) .OR. (count .LT. length))
		remainder = Mod(quotient ,16)
		if (remainder .LE. 9) then 
			hexChar = Char(remainder + 48)
		Else
		hexChar = char(remainder + 55)
		end If
		OUTDATA(i)=hexChar
		quotient = quotient / 16
		count = count + 1
		i =i+1
  End DO
        
END SUBROUTINE intTohex

!****************************************************************************
!
! End of  FUNCTION: intTohex
!
!****************************************************************************


!****************************************************************************
!
!  FUNCTION:  ToUpper(char1, validhex)
!
!  PURPOSE:  This function used to convert character to upercase and check for hex char
!
!****************************************************************************


subroutine  ToUpper(char1, validhex)
	character(kind=1) :: char1
	integer(kind=1) :: validhex
 if ((ichar(char1) .GE. 48 .AND.  ichar(char1) .LE. 57) .OR. (ichar(char1) .GE. 65 .AND. &
	 ichar(char1) .LE. 70) .OR. (ichar(char1) .GE. 97 .AND.  ichar(char1) .LE. 102)) then
			! if valid hex
			validhex=1
		else
			! if not valid hex then return 
			validhex=0
			return
		end if
	if (ichar(char1) .GE. 97 .AND.  ichar(char1) .LE. 102) then
		! convert from lower case to uper
			char1=char(ichar(char1) -32)
		end if
end subroutine

!****************************************************************************
!
! End of  FUNCTION: ToUpper
!
!****************************************************************************
