!       SPROMEPS.F90 
!       Sentinel Superpro Interface Prototype with FORTRAN 90
!  (C) Copyright 1991-2002 Rainbow Technologies, Inc. All rights reserved.
!Purpose :Here in this file we defined wrappers for All SuperPro APIs
!***********************************************************************
!DEC$ IF .NOT. DEFINED (SPROMEPS_MODULE_ )

!DEC$ DEFINE SPROMEPS_MODULE_  
!
module spromeps_Const
integer, parameter, public :: SPRO_APIPACKET_SIZE = 4112

	type APIPACKET
   sequence
   byte packet(SPRO_APIPACKET_SIZE)
	end type APIPACKET

	! Superpro API error codes
	integer, parameter, public :: SP_SUCCESS								              = 0
	integer, parameter, public :: SP_INVALID_FUNCTION_CODE	       = 1
	integer, parameter, public :: SP_INVALID_PACKET               = 2
	integer, parameter, public :: SP_UNIT_NOT_FOUND               = 3
	integer, parameter, public :: SP_ACCESS_DENIED                = 4
	integer, parameter, public :: SP_INVALID_MEMORY_ADDRESS       = 5
	integer, parameter, public :: SP_INVALID_ACCESS_CODE          = 6
	integer, parameter, public :: SP_PORT_IS_BUSY                 = 7
	integer, parameter, public :: SP_WRITE_NOT_READY              = 8
	integer, parameter, public :: SP_NO_PORT_FOUND                = 9
	integer, parameter, public :: SP_ALREADY_ZERO                 = 10
	integer, parameter, public :: SP_DRIVER_OPEN_ERROR            = 11
	integer, parameter, public :: SP_DRIVER_NOT_INSTALLED         = 12
	integer, parameter, public :: SP_IO_COMMUNICATIONS_ERROR      = 13
	integer, parameter, public :: SP_PACKET_TOO_SMALL             = 15
	integer, parameter, public :: SP_INVALID_PARAMETER            = 16
	integer, parameter, public :: SP_MEM_ACCESS_ERROR             = 17
	integer, parameter, public :: SP_VERSION_NOT_SUPPORTED        = 18
	integer, parameter, public :: SP_OS_NOT_SUPPORTED             = 19
	integer, parameter, public :: SP_QUERY_TOO_LONG               = 20
	integer, parameter, public :: SP_INVALID_COMMAND              = 21
	integer, parameter, public :: SP_MEM_ALIGNMENT_ERROR          = 29
	integer, parameter, public :: SP_DRIVER_IS_BUSY               = 30
	integer, parameter, public :: SP_PORT_ALLOCATION_FAILURE      = 31
	integer, parameter, public :: SP_PORT_RELEASE_FAILURE         = 32
	integer, parameter, public :: SP_ACQUIRE_PORT_TIMEOUT         = 39
	integer, parameter, public :: SP_SIGNAL_NOT_SUPPORTED         = 42
	integer, parameter, public :: SP_UNKNOWN_MACHINE              = 44
	integer, parameter, public :: SP_SYS_API_ERROR                = 45
	integer, parameter, public :: SP_UNIT_IS_BUSY                 = 46
	integer, parameter, public :: SP_INVALID_PORT_TYPE            = 47
	integer, parameter, public :: SP_INVALID_MACH_TYPE            = 48
	integer, parameter, public :: SP_INVALID_IRQ_MASK             = 49
	integer, parameter, public :: SP_INVALID_CONT_METHOD          = 50
	integer, parameter, public :: SP_INVALID_PORT_FLAGS           = 51
	integer, parameter, public :: SP_INVALID_LOG_PORT_CFG         = 52
	integer, parameter, public :: SP_INVALID_OS_TYPE              = 53
	integer, parameter, public :: SP_INVALID_LOG_PORT_NUM         = 54
	integer, parameter, public :: SP_INVALID_ROUTER_FLGS          = 56
	integer, parameter, public :: SP_INIT_NOT_CALLED              = 57
	integer, parameter, public :: SP_DRVR_TYPE_NOT_SUPPORTED      = 58
	integer, parameter, public :: SP_FAIL_ON_DRIVER_COMM          = 59
	integer, parameter, public :: SP_SERVER_PROBABLY_NOT_UP       = 60
	integer, parameter, public :: SP_UNKNOWN_HOST                 = 61
	integer, parameter, public :: SP_SENDTO_FAILED                = 62
	integer, parameter, public :: SP_SOCKET_CREATION_FAILED       = 63
	integer, parameter, public :: SP_NORESOURCES                  = 64
	integer, parameter, public :: SP_BROADCAST_NOT_SUPPORTED      = 65
	integer, parameter, public :: SP_BAD_SERVER_MESSAGE           = 66
	integer, parameter, public :: SP_NO_SERVER_RUNNING            = 67
	integer, parameter, public :: SP_NO_NETWORK                   = 68
	integer, parameter, public :: SP_NO_SERVER_RESPONSE           = 69
	integer, parameter, public :: SP_NO_LICENSE_AVAILABLE         = 70
	integer, parameter, public :: SP_INVALID_LICENSE              = 71
	integer, parameter, public :: SP_INVALID_OPERATION            = 72
	integer, parameter, public :: SP_BUFFER_TOO_SMALL             = 73
	integer, parameter, public :: SP_INTERNAL_ERROR               = 74
	integer, parameter, public :: SP_PACKET_ALREADY_INITIALIZED   = 75
	integer, parameter, public :: SP_PROTOCOL_NOT_INSTALLED       = 76

	
	! Driver type
	integer, parameter, public :: RB_WINNT_SYS_DRVR = 5
	integer, parameter, public :: RB_WIN95_SYS_DRVR = 7
	integer, parameter, public :: RB_NW_LOCAL_DRVR  = 8
	
	
	
	! Superpro Constants for heart beat value and server name 
	integer, parameter, public :: MAX_HEARTBEAT				    = 2592000
	integer, parameter, public :: MIN_HEARTBEAT				    = 60
	integer, parameter, public :: INFINITE_HEARTBEAT	  = -1
	
	integer, parameter, public :: MAX_NAME_LEN				     = 64
	integer, parameter, public :: MAX_ADDR_LEN				     = 32

	! Enum server falgs
	integer, parameter, public :: NSPRO_RET_ON_FIRST             = 1
	integer, parameter, public :: NSPRO_GET_ALL_SERVERS          = 2
 integer, parameter, public :: NSPRO_RET_ON_FIRST_AVAILABLE   = 4
	
	! Set Protocol falgs
	integer, parameter, public :: NSPRO_TCP_PROTOCOL        = 1
	integer, parameter, public :: NSPRO_IPX_PROTOCOL        = 2
	integer, parameter, public :: NSPRO_NETBEUI_PROTOCOL    = 4
	integer, parameter, public :: NSPRO_SAP_PROTOCOL        = 8

	! Some Constant for Input validation.
	integer, parameter, public :: VALID_DATA_LENGTH          = 4
	integer, parameter, public :: VALID_CELLADDRESS_LENGTH   = 2
	integer, parameter, public :: MAX_ACCESSCODE_RANGE       = 3
	integer, parameter, public :: MIN_ACCESSCODE_RANGE       = 0
	integer, parameter, public :: MAX_QUERYDATA_LENGTH       = 56
	integer, parameter, public :: MIN_QYERYDATA_LENGTH       = 8

	!reserve string for SetContactServer API
	character, public :: RNBO_STANDALONE         = "RNBO_STANDALONE"
	character, public :: RNBO_SPN_DRIVER         = "RNBO_SPN_DRIVER"
	character, public :: RNBO_SPN_LOCAL          = "RNBO_SPN_LOCAL"
	character, public :: RNBO_SPN_BROADCAST      = "RNBO_SPN_BROADCAST"
	character, public :: RNBO_SPN_ALL_MODES      = "RNBO_SPN_ALL_MODES"
	character, public :: RNBO_SPN_SERVER_MODES   = "RNBO_SPN_SERVER_MODES"

	! Monitoring information 
	type NSPRO_KEY_MONITOR_INFO 
		sequence
		integer(kind=2) ::	devId		!developer id of the key
		integer(kind=2) ::  hardLimit	!hardlimit of the key
		integer(kind=2) ::  inUse		!Number of licenses in use for the key
		integer(kind=2) ::  numTimeOut	! Number of timeouts recorded for the key
		integer(kind=2) ::  highestUse	! Highest number of licenses issued from 
										!the key throughout the life of server
	end type NSPRO_KEY_MONITOR_INFO

	type NSPRO_MONITOR_INFO
		sequence
		character*MAX_NAME_LEN        :: serverName
		character*MAX_ADDR_LEN        :: serverIPAddress
		character*MAX_ADDR_LEN        :: serverIPXAddress
		character*MAX_NAME_LEN        :: version
		integer(kind=2)               :: protocol
		type(NSPRO_KEY_MONITOR_INFO)  ::  sproKeyMonitorInfo;     
	end type NSPRO_MONITOR_INFO

	! Server information returned by RNBOsproEnumServer
	type NSPRO_SERVER_INFO
		sequence
		character*MAX_ADDR_LEN   :: serverAddress
		integer(kind=2)          :: numLicAvail
	end type NSPRO_SERVER_INFO

end module spromeps_Const




module spromeps_module
! Wrapper for RNBOsproFormatPacket

	interface !lib=sx32w.lib
	
	  integer(kind=2) function  RNBOsproFormatPacket ( packet,size )

	    use spromeps_Const 
		   !DEC$ ATTRIBUTES STDCALL, ALIAS :  '_RNBOsproFormatPacket@8'   :: RNBOsproFormatPacket
		   !DEC$ ATTRIBUTES REFERENCE :: packet
		   !DEC$ ATTRIBUTES VALUE :: size
		
	    integer(kind=4) size
	    byte			packet(SPRO_APIPACKET_SIZE)
		
		 end function RNBOsproFormatPacket
	end interface

! Wrapper for RNBOsproInitialize
	interface !lib=sx32w.lib
		integer(kind=2) function  RNBOsproInitialize ( packet ) 
		use spromeps_Const 
		!DEC$ ATTRIBUTES STDCALL, ALIAS :  '_RNBOsproInitialize@4'   :: RNBOsproInitialize
		!DEC$ ATTRIBUTES REFERENCE :: packet
		byte			packet(SPRO_APIPACKET_SIZE)
		end function RNBOsproInitialize
	end interface
	

! Wrapper for RNBOsproFindFirstUnit
	interface !lib=sx32w.lib
		integer(kind=2) function  RNBOsproFindFirstUnit ( packet, developerId ) 
		use spromeps_Const 
		!DEC$ ATTRIBUTES STDCALL, ALIAS :  '_RNBOsproFindFirstUnit@8'   :: RNBOsproFindFirstUnit
		!DEC$ ATTRIBUTES REFERENCE :: packet
		!DEC$ ATTRIBUTES VALUE :: developerId
			byte				packet(SPRO_APIPACKET_SIZE)
			integer(kind=4)		developerId
		end function RNBOsproFindFirstUnit
	end interface
	
! Wrapper for RNBOsproFindNextUnit
	interface !lib=sx32w.lib
		integer(kind=2) function  RNBOsproFindNextUnit ( packet ) 
		use spromeps_Const 
		!DEC$ ATTRIBUTES STDCALL, ALIAS :  '_RNBOsproFindNextUnit@4'   :: RNBOsproFindNextUnit
		!DEC$ ATTRIBUTES REFERENCE :: packet
			byte				packet(SPRO_APIPACKET_SIZE)
		end function RNBOsproFindNextUnit
	end interface

! Wrapper for RNBOsproRead
	interface !lib=sx32w.lib
		integer(kind=2) function  RNBOsproRead ( packet, cellAddress, dat ) 
		use spromeps_Const 
		!DEC$ ATTRIBUTES STDCALL, ALIAS :  '_RNBOsproRead@12'   :: RNBOsproRead
		!DEC$ ATTRIBUTES REFERENCE :: packet
		!DEC$ ATTRIBUTES VALUE :: cellAddress
		!DEC$ ATTRIBUTES REFERENCE :: dat
			byte				packet(SPRO_APIPACKET_SIZE)
			integer(kind=2)		cellAddress
			integer(kind=4)		dat
		end function RNBOsproRead
	end interface

! Wrapper for RNBOsproExtendedRead
	interface !lib=sx32w.lib
		integer(kind=2) function  RNBOsproExtendedRead ( packet, cellAddress, dat, accessCode ) 
		use spromeps_Const 
		!DEC$ ATTRIBUTES STDCALL, ALIAS :  '_RNBOsproExtendedRead@16'   :: RNBOsproExtendedRead
		!DEC$ ATTRIBUTES REFERENCE :: packet
		!DEC$ ATTRIBUTES VALUE :: cellAddress
		!DEC$ ATTRIBUTES REFERENCE :: dat
		!DEC$ ATTRIBUTES REFERENCE :: accessCode
			byte				packet(SPRO_APIPACKET_SIZE)
			integer(kind=2)		cellAddress
			integer(kind=4)		dat
			integer(kind=1)		accessCode
		end function RNBOsproExtendedRead
	end interface

! Wrapper for RNBOsproWrite
	interface !lib=sx32w.lib
		integer(kind=2) function  RNBOsproWrite ( packet, writePassword, cellAddress, dat, accessCode ) 
		use spromeps_Const 
		!DEC$ ATTRIBUTES STDCALL, ALIAS :  '_RNBOsproWrite@20'   :: RNBOsproWrite
		!DEC$ ATTRIBUTES REFERENCE :: packet
		!DEC$ ATTRIBUTES VALUE :: writePassword
		!DEC$ ATTRIBUTES VALUE :: cellAddress
		!DEC$ ATTRIBUTES VALUE :: dat
		!DEC$ ATTRIBUTES VALUE :: accessCode
			byte				packet(SPRO_APIPACKET_SIZE)
			integer(kind=4)		writePassword
			integer(kind=2)		cellAddress
			integer(kind=4)		dat
			integer(kind=1)		accessCode
		end function RNBOsproWrite
	end interface

! Wrapper for RNBOsproOverwrite
	interface !lib=sx32w.lib
		integer(kind=2) function  RNBOsproOverwrite ( packet, writePassword, overwritePassword1, overwritePassword2, cellAddress, dat, accessCode ) 
		use spromeps_Const 
		!DEC$ ATTRIBUTES STDCALL, ALIAS :  '_RNBOsproOverwrite@28'   :: RNBOsproOverwrite
		!DEC$ ATTRIBUTES REFERENCE :: packet
		!DEC$ ATTRIBUTES VALUE :: writePassword
		!DEC$ ATTRIBUTES VALUE :: overwritePassword1
		!DEC$ ATTRIBUTES VALUE :: overwritePassword2
		!DEC$ ATTRIBUTES VALUE :: cellAddress
		!DEC$ ATTRIBUTES VALUE :: dat
		!DEC$ ATTRIBUTES VALUE :: accessCode
			byte				packet(SPRO_APIPACKET_SIZE)
			integer(kind=4)		writePassword
			integer(kind=4)		overwritePassword1
			integer(kind=4)		overwritePassword2
			integer(kind=2)		cellAddress
			integer(kind=4)		dat
			integer(kind=1)		accessCode
		end function RNBOsproOverwrite
	end interface

! Wrapper for RNBOsproDecrement
	interface !lib=sx32w.lib
		integer(kind=2) function  RNBOsproDecrement ( packet, writePassword, cellAddress ) 
		use spromeps_Const 
		!DEC$ ATTRIBUTES STDCALL, ALIAS :  '_RNBOsproDecrement@12'   :: RNBOsproDecrement
		!DEC$ ATTRIBUTES REFERENCE :: packet
		!DEC$ ATTRIBUTES VALUE :: writePassword
		!DEC$ ATTRIBUTES VALUE :: cellAddress
			byte				packet(SPRO_APIPACKET_SIZE)
			integer(kind=4)		writePassword
			integer(kind=2)		cellAddress
		end function RNBOsproDecrement
	end interface

! Wrapper for RNBOsproActivate
	interface !lib=sx32w.lib
		integer(kind=2) function  RNBOsproActivate ( packet, writePassword, activatePassword1, activatePassword2, cellAddress ) 
		use spromeps_Const 
		!DEC$ ATTRIBUTES STDCALL, ALIAS :  '_RNBOsproActivate@20'   :: RNBOsproActivate
		!DEC$ ATTRIBUTES REFERENCE :: packet
		!DEC$ ATTRIBUTES VALUE :: writePassword
		!DEC$ ATTRIBUTES VALUE :: activatePassword1
		!DEC$ ATTRIBUTES VALUE :: activatePassword2
		!DEC$ ATTRIBUTES VALUE :: cellAddress
			byte				packet(SPRO_APIPACKET_SIZE)
			integer(kind=4)		writePassword
			integer(kind=4)		activatePassword1
			integer(kind=4)		activatePassword2
			integer(kind=2)		cellAddress
		end function RNBOsproActivate
	end interface

! Wrapper for RNBOsproQuery
	interface !lib=sx32w.lib
		integer(kind=2) function  RNBOsproQuery ( packet, cellAddress, queryData, response, response32, length ) 
		use spromeps_Const 
		!DEC$ ATTRIBUTES STDCALL, ALIAS :  '_RNBOsproQuery@24'   :: RNBOsproQuery
		!DEC$ ATTRIBUTES REFERENCE :: packet
		!DEC$ ATTRIBUTES VALUE :: cellAddress
		!DEC$ ATTRIBUTES REFERENCE :: queryData
		!DEC$ ATTRIBUTES REFERENCE :: response
		!DEC$ ATTRIBUTES REFERENCE :: response32
		!DEC$ ATTRIBUTES VALUE :: length
			byte				packet(SPRO_APIPACKET_SIZE)
			integer(kind=2)		cellAddress
			character(kind=1)		queryData(*)
			integer(kind=1)		response(*)
			integer(kind=4)		response32
			integer(kind=2)		length
		end function RNBOsproQuery
	end interface

! Wrapper for RNBOsproGetFullStatus
	interface !lib=sx32w.lib
		integer(kind=2) function  RNBOsproGetFullStatus ( packet ) 
		use spromeps_Const 
		!DEC$ ATTRIBUTES STDCALL, ALIAS :  '_RNBOsproGetFullStatus@4'   :: RNBOsproGetFullStatus
		!DEC$ ATTRIBUTES REFERENCE :: packet
			byte				packet(SPRO_APIPACKET_SIZE)
		end function RNBOsproGetFullStatus
	end interface

! Wrapper for RNBOsproGetVersion
	interface !lib=sx32w.lib
		integer(kind=2) function  RNBOsproGetVersion ( packet, majorVersion, minorVersion, revision, osType ) 
		use spromeps_Const 
		!DEC$ ATTRIBUTES STDCALL, ALIAS :  '_RNBOsproGetVersion@20'   :: RNBOsproGetVersion
		!DEC$ ATTRIBUTES REFERENCE :: packet
		!DEC$ ATTRIBUTES REFERENCE :: majorVersion
		!DEC$ ATTRIBUTES REFERENCE :: minorVersion
		!DEC$ ATTRIBUTES REFERENCE :: revision
		!DEC$ ATTRIBUTES REFERENCE :: osType
			byte				packet(SPRO_APIPACKET_SIZE)
			integer(kind=1)		majorVersion
			integer(kind=1)		minorVersion
			integer(kind=1)		revision
			integer(kind=1)		osType
		end function RNBOsproGetVersion
	end interface

! Wrapper for RNBOsproGetHardLimit
	interface !lib=sx32w.lib
		integer(kind=2) function  RNBOsproGetHardLimit ( packet, hardLimit ) 
		use spromeps_Const 
		!DEC$ ATTRIBUTES STDCALL, ALIAS :  '_RNBOsproGetHardLimit@8'   :: RNBOsproGetHardLimit
		!DEC$ ATTRIBUTES REFERENCE :: packet
		!DEC$ ATTRIBUTES REFERENCE :: hardLimit
			byte				packet(SPRO_APIPACKET_SIZE)
			integer(kind=4)		hardLimit
		end function RNBOsproGetHardLimit
	end interface

! Wrapper for RNBOsproGetSubLicense
	interface !lib=sx32w.lib
		integer(kind=2) function  RNBOsproGetSubLicense ( packet, cellAddress ) 
		use spromeps_Const 
		!DEC$ ATTRIBUTES STDCALL, ALIAS :  '_RNBOsproGetSubLicense@8'   :: RNBOsproGetSubLicense
		!DEC$ ATTRIBUTES REFERENCE :: packet
		!DEC$ ATTRIBUTES VALUE :: cellAddress
			byte				packet(SPRO_APIPACKET_SIZE)
			integer(kind=2)		cellAddress
		end function RNBOsproGetSubLicense
	end interface

! Wrapper for RNBOsproReleaseLicense
	interface !lib=sx32w.lib
		integer(kind=2) function  RNBOsproReleaseLicense ( packet, cellAddress, numberOfLicense ) 
		use spromeps_Const 
		!DEC$ ATTRIBUTES STDCALL, ALIAS :  '_RNBOsproReleaseLicense@12'   :: RNBOsproReleaseLicense
		!DEC$ ATTRIBUTES REFERENCE :: packet
		!DEC$ ATTRIBUTES VALUE :: cellAddress
		!DEC$ ATTRIBUTES REFERENCE :: numberOfLicense
			
			byte				packet(SPRO_APIPACKET_SIZE)
			integer(kind=2)	cellAddress
			integer(kind=4)		numberOfLicense
		end function RNBOsproReleaseLicense
	end interface

! Wrapper for RNBOsproSetContactServer
	interface !lib=sx32w.lib
		integer(kind=2) function  RNBOsproSetContactServer ( packet, serverName ) 
		use spromeps_Const 
		!DEC$ ATTRIBUTES STDCALL, ALIAS :  '_RNBOsproSetContactServer@8'   :: RNBOsproSetContactServer
		!DEC$ ATTRIBUTES REFERENCE :: packet
		!DEC$ ATTRIBUTES REFERENCE :: serverName
			byte				packet(SPRO_APIPACKET_SIZE)
			character*(*)		serverName
		end function RNBOsproSetContactServer
	end interface

! Wrapper for RNBOsproGetContactServer
	interface !lib=sx32w.lib
		integer(kind=2) function  RNBOsproGetContactServer ( packet, serverName, serverNameBufSize ) 
		use spromeps_Const 
		!DEC$ ATTRIBUTES STDCALL, ALIAS :  '_RNBOsproGetContactServer@12'   :: RNBOsproGetContactServer
		!DEC$ ATTRIBUTES REFERENCE :: packet
		!DEC$ ATTRIBUTES REFERENCE :: serverName
		!DEC$ ATTRIBUTES VALUE :: serverNameBufSize
			byte				packet(SPRO_APIPACKET_SIZE)
			character*(*)		serverName
			integer(kind=2)		serverNameBufSize
		end function RNBOsproGetContactServer
	end interface

! Wrapper for RNBOsproEnumServer
	interface !lib=sx32w.lib
		integer(kind=2) function  RNBOsproEnumServer ( enumFlag, developerId, serverInfo, numServerInfo ) 
		use spromeps_Const 
		!DEC$ ATTRIBUTES STDCALL, ALIAS :  '_RNBOsproEnumServer@16'   :: RNBOsproEnumServer
		!DEC$ ATTRIBUTES VALUE :: enumFlag
		!DEC$ ATTRIBUTES VALUE :: developerId
		!DEC$ ATTRIBUTES REFERENCE :: serverInfo
		!DEC$ ATTRIBUTES REFERENCE :: numServerInfo
			integer(kind=1)			enumFlag
			integer(kind=4)			developerId
			type(NSPRO_SERVER_INFO) serverInfo(*)
			integer(kind=2)			numServerInfo
		end function RNBOsproEnumServer
	end interface

! Wrapper for RNBOsproGetKeyInfo
	interface !lib=sx32w.lib
		integer(kind=2) function  RNBOsproGetKeyInfo ( packet, developerId, keyIndex, monitorInfo ) 
		use spromeps_Const 
		!DEC$ ATTRIBUTES STDCALL, ALIAS :  '_RNBOsproGetKeyInfo@16'   :: RNBOsproGetKeyInfo
		!DEC$ ATTRIBUTES REFERENCE :: packet
		!DEC$ ATTRIBUTES VALUE :: developerId
		!DEC$ ATTRIBUTES VALUE :: keyIndex
		!DEC$ ATTRIBUTES REFERENCE :: monitorInfo
			byte					packet(SPRO_APIPACKET_SIZE)
			integer(kind=1)			keyIndex
			integer(kind=4)			developerId
			type(NSPRO_MONITOR_INFO)	monitorInfo
		end function RNBOsproGetKeyInfo
	end interface

! Wrapper for RNBOsproSetProtocol
	interface !lib=sx32w.lib
		integer(kind=2) function  RNBOsproSetProtocol ( packet, protocolFlag )
		 use spromeps_Const 
		!DEC$ ATTRIBUTES STDCALL, ALIAS :  '_RNBOsproSetProtocol@8'   :: RNBOsproSetProtocol
		!DEC$ ATTRIBUTES REFERENCE :: packet
		!DEC$ ATTRIBUTES VALUE :: protocolFlag
			byte					packet(SPRO_APIPACKET_SIZE)
			integer(kind=1)			protocolFlag
		end function RNBOsproSetProtocol
	end interface

! Wrapper for RNBOsproSetHeartBeat
	interface !lib=sx32w.lib
		integer(kind=2) function  RNBOsproSetHeartBeat ( packet, heartBeat )
		 use spromeps_Const 
		!DEC$ ATTRIBUTES STDCALL, ALIAS :  '_RNBOsproSetHeartBeat@8'   :: RNBOsproSetHeartBeat
		!DEC$ ATTRIBUTES REFERENCE :: packet
		!DEC$ ATTRIBUTES VALUE :: heartBeat
			byte					packet(SPRO_APIPACKET_SIZE)
			integer(kind=4)			heartBeat
		end function RNBOsproSetHeartBeat
	end interface
   

end module spromeps_module
!
!DEC$ ENDIF ! /* SPROMEPS_MODULE_ */
